Tonyu.klass.define({
  fullName: 'user.Ball',
  shortName: 'Ball',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_Ball_main() {
      "use strict";
      var _this=this;
      
      
    },
    fiber$main :function _trc_Ball_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      
      _thread.retVal=_this;return;
    },
    onAppear :function _trc_Ball_onAppear() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=1000029;//user.Ball:29
      _this.shade=new Tonyu.classes.kernel.ActorSprite({x: _this.x,y: _this.y,p: Tonyu.globals.$pshade});
    },
    fiber$onAppear :function _trc_Ball_f_onAppear(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=1000029;//user.Ball:29
      _this.shade=new Tonyu.classes.kernel.ActorSprite({x: _this.x,y: _this.y,p: Tonyu.globals.$pshade});
      
      _thread.retVal=_this;return;
    },
    draw :function _trc_Ball_draw(ctx) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=1000087;//user.Ball:87
      Tonyu.classes.kernel.Actor.prototype.draw.apply( _this, [ctx]);
      //$LASTPOS=1000108;//user.Ball:108
      _this.shade.x=_this.x;
      //$LASTPOS=1000123;//user.Ball:123
      _this.shade.y=_this.y;
      //$LASTPOS=1000138;//user.Ball:138
      _this.shade.draw(ctx);
    },
    chainable :function _trc_Ball_chainable(b) {
      "use strict";
      var _this=this;
      
      return _this.col===b.col||_this.letter===b.letter||_this.col===b.letter||_this.letter===b.col;
    },
    fiber$chainable :function _trc_Ball_f_chainable(_thread,b) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      _thread.retVal=_this.col===b.col||_this.letter===b.letter||_this.col===b.letter||_this.letter===b.col;return;
      
      
      _thread.retVal=_this;return;
    },
    __getter__basep :function _trc_Ball___getter__basep() {
      "use strict";
      var _this=this;
      
      return _this.p-Tonyu.globals.$pat_iroball;
    },
    __getter__col :function _trc_Ball___getter__col() {
      "use strict";
      var _this=this;
      
      return _this.basep%5;
    },
    __getter__letter :function _trc_Ball___getter__letter() {
      "use strict";
      var _this=this;
      
      return _this.floor(_this.basep/5);
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"onAppear":{"nowait":false},"draw":{"nowait":true},"chainable":{"nowait":false},"__getter__basep":{"nowait":true},"__getter__col":{"nowait":true},"__getter__letter":{"nowait":true}},"fields":{"shade":{}}}
});
Tonyu.klass.define({
  fullName: 'user.BG',
  shortName: 'BG',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Map,
  includes: [],
  methods: {
    main :function _trc_BG_main() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=2000328;//user.BG:328
      _this.y=0;
      //$LASTPOS=2000333;//user.BG:333
      while (true) {
        Tonyu.checkLoop();
        //$LASTPOS=2000351;//user.BG:351
        _this.scrollBy(0.2);
        //$LASTPOS=2000370;//user.BG:370
        _this.update();
        
      }
    },
    fiber$main :function _trc_BG_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=2000328;//user.BG:328
      _this.y=0;
      
      _thread.enter(function _trc_BG_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=2000333;//user.BG:333
          case 1:
            //$LASTPOS=2000351;//user.BG:351
            _this.fiber$scrollBy(_thread, 0.2);
            __pc=2;return;
          case 2:
            
            //$LASTPOS=2000370;//user.BG:370
            _this.fiber$update(_thread);
            __pc=3;return;
          case 3:
            
            __pc=1;break;
          case 4     :
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    initialize :function _trc_BG_initialize(p) {
      "use strict";
      var _this=this;
      var i;
      var j;
      
      //$LASTPOS=2000028;//user.BG:28
      Tonyu.classes.kernel.Map.apply( _this, [{row: _this.floor(Tonyu.globals.$screenHeight/32)+1,col: _this.floor(Tonyu.globals.$screenWidth/32),chipWidth: 32}]);
      //$LASTPOS=2000115;//user.BG:115
      //$LASTPOS=2000120;//user.BG:120
      i = 0;
      for (; i<_this.row ; i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2000149;//user.BG:149
          //$LASTPOS=2000154;//user.BG:154
          j = 0;
          for (; j<_this.col ; j++) {
            Tonyu.checkLoop();
            {
              //$LASTPOS=2000187;//user.BG:187
              _this.set(j,i,p);
            }
          }
        }
      }
    },
    scroll :function _trc_BG_scroll(y) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=2000258;//user.BG:258
      _this.scrollTo(0,32+y%32);
    },
    fiber$scroll :function _trc_BG_f_scroll(_thread,y) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      _thread.enter(function _trc_BG_ent_scroll(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=2000258;//user.BG:258
            _this.fiber$scrollTo(_thread, 0, 32+y%32);
            __pc=1;return;
          case 1:
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    scrollBy :function _trc_BG_scrollBy(_y) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=2000303;//user.BG:303
      _this.y-=_y;
      //$LASTPOS=2000314;//user.BG:314
      _this.scroll(_this.y);
    },
    fiber$scrollBy :function _trc_BG_f_scrollBy(_thread,_y) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=2000303;//user.BG:303
      _this.y-=_y;
      
      _thread.enter(function _trc_BG_ent_scrollBy(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=2000314;//user.BG:314
            _this.fiber$scroll(_thread, _this.y);
            __pc=1;return;
          case 1:
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"scroll":{"nowait":false},"scrollBy":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.BtScreen',
  shortName: 'BtScreen',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Screen,
  includes: [],
  methods: {
    main :function _trc_BtScreen_main() {
      "use strict";
      var _this=this;
      
      
    },
    fiber$main :function _trc_BtScreen_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      
      _thread.retVal=_this;return;
    },
    onAppear :function _trc_BtScreen_onAppear() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=3000047;//user.BtScreen:47
      _this.btLayer=_this.addLayer();
      //$LASTPOS=3000071;//user.BtScreen:71
      Tonyu.globals.$pp=new Tonyu.classes.user.PParty({layer: _this.btLayer,scr: _this});
      //$LASTPOS=3000115;//user.BtScreen:115
      Tonyu.globals.$ep=new Tonyu.classes.user.EParty({layer: _this.btLayer,scr: _this});
      //$LASTPOS=3000159;//user.BtScreen:159
      Tonyu.globals.$console=new Tonyu.classes.user.DotConsole({layer: _this.btLayer,font: Tonyu.globals.$pat_font_b,size: 8,zOrder: - 10});
    },
    fiber$onAppear :function _trc_BtScreen_f_onAppear(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      _thread.enter(function _trc_BtScreen_ent_onAppear(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=3000047;//user.BtScreen:47
            _this.fiber$addLayer(_thread);
            __pc=1;return;
          case 1:
            _this.btLayer=_thread.retVal;
            
            //$LASTPOS=3000071;//user.BtScreen:71
            Tonyu.globals.$pp=new Tonyu.classes.user.PParty({layer: _this.btLayer,scr: _this});
            //$LASTPOS=3000115;//user.BtScreen:115
            Tonyu.globals.$ep=new Tonyu.classes.user.EParty({layer: _this.btLayer,scr: _this});
            //$LASTPOS=3000159;//user.BtScreen:159
            Tonyu.globals.$console=new Tonyu.classes.user.DotConsole({layer: _this.btLayer,font: Tonyu.globals.$pat_font_b,size: 8,zOrder: - 10});
            _thread.exit(_this);return;
          }
        }
      });
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"onAppear":{"nowait":false}},"fields":{"btLayer":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Chain',
  shortName: 'Chain',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_Chain_main() {
      "use strict";
      var _this=this;
      var _it_3;
      
      
      //$LASTPOS=4000011;//user.Chain:11
      _this.path = [{gx: _this.gx,gy: _this.gy,b: Tonyu.globals.$pzScreen.getSBall(_this.gx,_this.gy)}];
      
      
      //$LASTPOS=4000071;//user.Chain:71
      while (Tonyu.globals.$touches[0].touched) {
        Tonyu.checkLoop();
        //$LASTPOS=4000105;//user.Chain:105
        _this.g = Tonyu.globals.$pzScreen.grid(Tonyu.globals.$touches[0]);
        
        //$LASTPOS=4000144;//user.Chain:144
        Tonyu.globals.$pzScreen.zoom(Tonyu.globals.$pzScreen.toLocal(Tonyu.globals.$touches[0]));
        //$LASTPOS=4000196;//user.Chain:196
        if (_this.abs(_this.g.gx-_this.gx)+_this.abs(_this.g.gy-_this.gy)==1) {
          //$LASTPOS=4000240;//user.Chain:240
          _this.b = Tonyu.globals.$pzScreen.getSBall(_this.g.gx,_this.g.gy);
          
          //$LASTPOS=4000285;//user.Chain:285
          _this.lastb = _this.path[_this.path.length-1].b;
          
          //$LASTPOS=4000326;//user.Chain:326
          if (_this.b&&! _this.b.inchain) {
            //$LASTPOS=4000361;//user.Chain:361
            if (_this.lastb.chainable(_this.b)) {
              //$LASTPOS=4000403;//user.Chain:403
              _this.gx=_this.g.gx;
              //$LASTPOS=4000428;//user.Chain:428
              _this.gy=_this.g.gy;
              //$LASTPOS=4000453;//user.Chain:453
              _this.b.inchain=true;
              //$LASTPOS=4000582;//user.Chain:582
              _this.path.push({gx: _this.gx,gy: _this.gy,b: _this.b});
              
            } else {
              //$LASTPOS=4000639;//user.Chain:639
              _this.missed=true;
              break;
              
              
            }
            
          }
          
        }
        //$LASTPOS=4000742;//user.Chain:742
        _this.update();
        
      }
      //$LASTPOS=4000754;//user.Chain:754
      _this.pow = _this.path.length;
      
      //$LASTPOS=4000775;//user.Chain:775
      _it_3=Tonyu.iterator(_this.path,1);
      while(_it_3.next()) {
        _this.p=_it_3[0];
        
        //$LASTPOS=4000801;//user.Chain:801
        _this.b = _this.p.b;
        
        //$LASTPOS=4000816;//user.Chain:816
        if (_this.missed) {
          //$LASTPOS=4000838;//user.Chain:838
          _this.ep = Tonyu.globals.$ep.random();
          
          //$LASTPOS=4000867;//user.Chain:867
          if (_this.ep) {
            //$LASTPOS=4000889;//user.Chain:889
            new Tonyu.classes.user.Effect({src: _this.b,dst: _this.ep,pow: _this.pow*3});
            
          }
          
        } else {
          //$LASTPOS=4000958;//user.Chain:958
          _this.pp = Tonyu.globals.$pp.find(_this.b.col);
          
          //$LASTPOS=4000990;//user.Chain:990
          if (_this.pp) {
            //$LASTPOS=4001012;//user.Chain:1012
            new Tonyu.classes.user.Effect({src: _this.b,dst: _this.pp,pow: _this.pow});
            
          }
          
        }
        //$LASTPOS=4001063;//user.Chain:1063
        _this.b.die();
        //$LASTPOS=4001076;//user.Chain:1076
        Tonyu.globals.$pzScreen.rm(_this.p.gx,_this.p.gy);
        //$LASTPOS=4001105;//user.Chain:1105
        _this.updateEx(3);
        
      }
      //$LASTPOS=4001120;//user.Chain:1120
      Tonyu.globals.$pzScreen.fill();
      //$LASTPOS=4001154;//user.Chain:1154
      Tonyu.globals.$pzScreen.zoom();
      //$LASTPOS=4001172;//user.Chain:1172
      _this.die();
    },
    fiber$main :function _trc_Chain_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var _it_3;
      
      
      //$LASTPOS=4000011;//user.Chain:11
      _this.path = [{gx: _this.gx,gy: _this.gy,b: Tonyu.globals.$pzScreen.getSBall(_this.gx,_this.gy)}];
      
      
      
      _thread.enter(function _trc_Chain_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=4000071;//user.Chain:71
          case 1:
            if (!(Tonyu.globals.$touches[0].touched)) { __pc=7     ; break; }
            //$LASTPOS=4000105;//user.Chain:105
            _this.g = Tonyu.globals.$pzScreen.grid(Tonyu.globals.$touches[0]);
            
            //$LASTPOS=4000144;//user.Chain:144
            Tonyu.globals.$pzScreen.zoom(Tonyu.globals.$pzScreen.toLocal(Tonyu.globals.$touches[0]));
            //$LASTPOS=4000196;//user.Chain:196
            if (!(_this.abs(_this.g.gx-_this.gx)+_this.abs(_this.g.gy-_this.gy)==1)) { __pc=5     ; break; }
            //$LASTPOS=4000240;//user.Chain:240
            _this.b = Tonyu.globals.$pzScreen.getSBall(_this.g.gx,_this.g.gy);
            
            //$LASTPOS=4000285;//user.Chain:285
            _this.lastb = _this.path[_this.path.length-1].b;
            
            //$LASTPOS=4000326;//user.Chain:326
            if (!(_this.b&&! _this.b.inchain)) { __pc=4     ; break; }
            //$LASTPOS=4000361;//user.Chain:361
            if (!(_this.lastb.chainable(_this.b))) { __pc=2     ; break; }
            {
              //$LASTPOS=4000403;//user.Chain:403
              _this.gx=_this.g.gx;
              //$LASTPOS=4000428;//user.Chain:428
              _this.gy=_this.g.gy;
              //$LASTPOS=4000453;//user.Chain:453
              _this.b.inchain=true;
              //$LASTPOS=4000582;//user.Chain:582
              _this.path.push({gx: _this.gx,gy: _this.gy,b: _this.b});
            }
            __pc=3     ;break;
          case 2     :
            //$LASTPOS=4000639;//user.Chain:639
            _this.missed=true;
            __pc=7     ; break;
            
          case 3     :
            
          case 4     :
            
          case 5     :
            
            //$LASTPOS=4000742;//user.Chain:742
            _this.fiber$update(_thread);
            __pc=6;return;
          case 6:
            
            __pc=1;break;
          case 7     :
            
            //$LASTPOS=4000754;//user.Chain:754
            _this.pow = _this.path.length;
            
            //$LASTPOS=4000775;//user.Chain:775
            _it_3=Tonyu.iterator(_this.path,1);
          case 8:
            if (!(_it_3.next())) { __pc=10    ; break; }
            _this.p=_it_3[0];
            
            //$LASTPOS=4000801;//user.Chain:801
            _this.b = _this.p.b;
            
            //$LASTPOS=4000816;//user.Chain:816
            if (_this.missed) {
              //$LASTPOS=4000838;//user.Chain:838
              _this.ep = Tonyu.globals.$ep.random();
              
              //$LASTPOS=4000867;//user.Chain:867
              if (_this.ep) {
                //$LASTPOS=4000889;//user.Chain:889
                new Tonyu.classes.user.Effect({src: _this.b,dst: _this.ep,pow: _this.pow*3});
                
              }
              
            } else {
              //$LASTPOS=4000958;//user.Chain:958
              _this.pp = Tonyu.globals.$pp.find(_this.b.col);
              
              //$LASTPOS=4000990;//user.Chain:990
              if (_this.pp) {
                //$LASTPOS=4001012;//user.Chain:1012
                new Tonyu.classes.user.Effect({src: _this.b,dst: _this.pp,pow: _this.pow});
                
              }
              
            }
            //$LASTPOS=4001063;//user.Chain:1063
            _this.b.die();
            //$LASTPOS=4001076;//user.Chain:1076
            Tonyu.globals.$pzScreen.rm(_this.p.gx,_this.p.gy);
            //$LASTPOS=4001105;//user.Chain:1105
            _this.fiber$updateEx(_thread, 3);
            __pc=9;return;
          case 9:
            
            __pc=8;break;
          case 10    :
            
            //$LASTPOS=4001120;//user.Chain:1120
            Tonyu.globals.$pzScreen.fill();
            //$LASTPOS=4001154;//user.Chain:1154
            Tonyu.globals.$pzScreen.zoom();
            //$LASTPOS=4001172;//user.Chain:1172
            _this.die();
            _thread.exit(_this);return;
          }
        }
      });
    },
    draw :function _trc_Chain_draw(ctx) {
      "use strict";
      var _this=this;
      var t;
      var c;
      var p;
      var _it_5;
      var l;
      
      //$LASTPOS=4001197;//user.Chain:1197
      t = new Tonyu.classes.user.Turtle(ctx,_this.path[0].gx*32+16,_this.path[0].gy*32+16);
      
      //$LASTPOS=4001258;//user.Chain:1258
      c = new Tonyu.classes.kernel.Color({h: Tonyu.globals.$frameCount,s: 1,l: 0.5});
      
      //$LASTPOS=4001305;//user.Chain:1305
      t.fillStyle=c;
      //$LASTPOS=4001324;//user.Chain:1324
      t.strokeStyle=c;
      //$LASTPOS=4001345;//user.Chain:1345
      t.lineWidth=3;
      //$LASTPOS=4001392;//user.Chain:1392
      _it_5=Tonyu.iterator(_this.path,1);
      while(_it_5.next()) {
        p=_it_5[0];
        
        //$LASTPOS=4001422;//user.Chain:1422
        t.lineTo(p.gx*32+16,p.gy*32+16);
        //$LASTPOS=4001463;//user.Chain:1463
        t.circle(5);
        
      }
      //$LASTPOS=4001530;//user.Chain:1530
      l = Tonyu.globals.$pzScreen.toLocal(Tonyu.globals.$touches[0]);
      
      //$LASTPOS=4001572;//user.Chain:1572
      t.lineTo(l.x,l.y);
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"draw":{"nowait":true}},"fields":{"gx":{},"gy":{},"path":{},"missed":{},"g":{},"b":{},"lastb":{},"pow":{},"p":{},"ep":{},"pp":{}}}
});
Tonyu.klass.define({
  fullName: 'user.ColorSprite',
  shortName: 'ColorSprite',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Panel,
  includes: [],
  methods: {
    main :function _trc_ColorSprite_main() {
      "use strict";
      var _this=this;
      
    },
    fiber$main :function _trc_ColorSprite_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      _thread.retVal=_this;return;
    },
    draw :function _trc_ColorSprite_draw(ctx) {
      "use strict";
      var _this=this;
      var i;
      
      //$LASTPOS=5000033;//user.ColorSprite:33
      i = Tonyu.globals.$imageList[_this.p];
      
      //$LASTPOS=5000058;//user.ColorSprite:58
      if (i) {
        //$LASTPOS=5000074;//user.ColorSprite:74
        if (i.width!=_this.width||i.height!=_this.height) {
          //$LASTPOS=5000128;//user.ColorSprite:128
          _this.resize(i.width,i.height);
          
        }
        //$LASTPOS=5000173;//user.ColorSprite:173
        _this.clearRect();
        //$LASTPOS=5000194;//user.ColorSprite:194
        _this.drawSprite(_this.width/2,_this.height/2,_this.p);
        //$LASTPOS=5000234;//user.ColorSprite:234
        _this.replaceColor(_this.fillStyle);
        
      }
      //$LASTPOS=5000269;//user.ColorSprite:269
      Tonyu.classes.kernel.Panel.prototype.draw.apply( _this, [ctx]);
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"draw":{"nowait":true}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.DBall',
  shortName: 'DBall',
  namespace: 'user',
  superclass: Tonyu.classes.user.Ball,
  includes: [],
  methods: {
    main :function _trc_DBall_main() {
      "use strict";
      var _this=this;
      
      
      //$LASTPOS=6000024;//user.DBall:24
      _this.drop();
    },
    fiber$main :function _trc_DBall_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      
      _thread.enter(function _trc_DBall_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=6000024;//user.DBall:24
            _this.fiber$drop(_thread);
            __pc=1;return;
          case 1:
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    drop :function _trc_DBall_drop() {
      "use strict";
      var _this=this;
      var gx;
      var gy;
      var b;
      
      
      //$LASTPOS=6000061;//user.DBall:61
      while (true) {
        Tonyu.checkLoop();
        //$LASTPOS=6000083;//user.DBall:83
        _this.y+=8;
        //$LASTPOS=6000115;//user.DBall:115
        gx=_this.floor(_this.x/32);
        //$LASTPOS=6000139;//user.DBall:139
        gy=_this.floor(_this.y/32);
        //$LASTPOS=6000163;//user.DBall:163
        if (gy==Tonyu.globals.$r-1||_this.scr.getSBall(gx,gy+1)!=null) {
          break;
          
          
        }
        //$LASTPOS=6000370;//user.DBall:370
        _this.update();
        
      }
      //$LASTPOS=6000417;//user.DBall:417
      while (_this.y<gy*32+16) {
        Tonyu.checkLoop();
        //$LASTPOS=6000445;//user.DBall:445
        _this.y+=8;
        //$LASTPOS=6000459;//user.DBall:459
        _this.update();
        
      }
      //$LASTPOS=6000479;//user.DBall:479
      _this.y=gy*32+16;
      //$LASTPOS=6000515;//user.DBall:515
      b = _this.scr.genSBall(gx,gy,_this.p);
      
      //$LASTPOS=6000553;//user.DBall:553
      _this.die();
    },
    fiber$drop :function _trc_DBall_f_drop(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var gx;
      var gy;
      var b;
      
      
      
      _thread.enter(function _trc_DBall_ent_drop(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=6000061;//user.DBall:61
          case 1:
            //$LASTPOS=6000083;//user.DBall:83
            _this.y+=8;
            //$LASTPOS=6000115;//user.DBall:115
            gx=_this.floor(_this.x/32);
            //$LASTPOS=6000139;//user.DBall:139
            gy=_this.floor(_this.y/32);
            //$LASTPOS=6000163;//user.DBall:163
            if (!(gy==Tonyu.globals.$r-1||_this.scr.getSBall(gx,gy+1)!=null)) { __pc=2     ; break; }
            __pc=4     ; break;
            
          case 2     :
            
            //$LASTPOS=6000370;//user.DBall:370
            _this.fiber$update(_thread);
            __pc=3;return;
          case 3:
            
            __pc=1;break;
          case 4     :
            
            //$LASTPOS=6000417;//user.DBall:417
          case 5:
            if (!(_this.y<gy*32+16)) { __pc=7     ; break; }
            //$LASTPOS=6000445;//user.DBall:445
            _this.y+=8;
            //$LASTPOS=6000459;//user.DBall:459
            _this.fiber$update(_thread);
            __pc=6;return;
          case 6:
            
            __pc=5;break;
          case 7     :
            
            //$LASTPOS=6000479;//user.DBall:479
            _this.y=gy*32+16;
            //$LASTPOS=6000515;//user.DBall:515
            b = _this.scr.genSBall(gx,gy,_this.p);
            
            //$LASTPOS=6000553;//user.DBall:553
            _this.die();
            _thread.exit(_this);return;
          }
        }
      });
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"drop":{"nowait":false}},"fields":{"scr":{}}}
});
Tonyu.klass.define({
  fullName: 'user.DotConsole',
  shortName: 'DotConsole',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Panel,
  includes: [],
  methods: {
    main :function _trc_DotConsole_main() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=7000015;//user.DotConsole:15
      "field strict";
      
    },
    fiber$main :function _trc_DotConsole_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=7000015;//user.DotConsole:15
      "field strict";
      
      
      _thread.retVal=_this;return;
    },
    initialize :function _trc_DotConsole_initialize(p) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=7000078;//user.DotConsole:78
      p=p||{};
      //$LASTPOS=7000091;//user.DotConsole:91
      p.size=p.size||16;
      //$LASTPOS=7000114;//user.DotConsole:114
      p.width=p.width||Tonyu.globals.$screenWidth;
      //$LASTPOS=7000149;//user.DotConsole:149
      p.height=p.height||Tonyu.globals.$screenHeight;
      //$LASTPOS=7000187;//user.DotConsole:187
      p.row=p.row||_this.floor(p.height/p.size);
      //$LASTPOS=7000228;//user.DotConsole:228
      p.col=p.col||_this.floor(p.width/p.size);
      //$LASTPOS=7000268;//user.DotConsole:268
      p.width=p.col*p.size;
      //$LASTPOS=7000294;//user.DotConsole:294
      p.height=p.row*p.size;
      //$LASTPOS=7000321;//user.DotConsole:321
      Tonyu.classes.kernel.Panel.apply( _this, [p]);
      //$LASTPOS=7000335;//user.DotConsole:335
      _this.cx=0;
      //$LASTPOS=7000340;//user.DotConsole:340
      _this.cy=0;
      //$LASTPOS=7000350;//user.DotConsole:350
      _this.fillStyle="white";
      //$LASTPOS=7000373;//user.DotConsole:373
      _this.mat=new Tonyu.classes.kernel.Matrix;
    },
    locate :function _trc_DotConsole_locate(x,y) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=7000411;//user.DotConsole:411
      _this.cx=x;
      //$LASTPOS=7000416;//user.DotConsole:416
      _this.cy=y;
    },
    fiber$locate :function _trc_DotConsole_f_locate(_thread,x,y) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=7000411;//user.DotConsole:411
      _this.cx=x;
      //$LASTPOS=7000416;//user.DotConsole:416
      _this.cy=y;
      
      _thread.retVal=_this;return;
    },
    print :function _trc_DotConsole_print(s) {
      "use strict";
      var _this=this;
      var i;
      var ch;
      
      //$LASTPOS=7000441;//user.DotConsole:441
      //$LASTPOS=7000446;//user.DotConsole:446
      i = 0;
      for (; i<s.length ; i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=7000480;//user.DotConsole:480
          ch = s.charCodeAt(i);
          
          //$LASTPOS=7000512;//user.DotConsole:512
          _this.putchar(ch);
        }
      }
    },
    putchar :function _trc_DotConsole_putchar(ch) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=7000552;//user.DotConsole:552
      if (ch!==10) {
        //$LASTPOS=7000575;//user.DotConsole:575
        _this.poke(_this.cx,_this.cy,ch);
        //$LASTPOS=7000599;//user.DotConsole:599
        _this.cx++;
        
      }
      //$LASTPOS=7000615;//user.DotConsole:615
      if (_this.cx>=_this.col||ch===10) {
        //$LASTPOS=7000649;//user.DotConsole:649
        _this.cx=0;
        //$LASTPOS=7000663;//user.DotConsole:663
        _this.cy++;
        //$LASTPOS=7000677;//user.DotConsole:677
        if (_this.cy>=_this.row) {
          //$LASTPOS=7000704;//user.DotConsole:704
          _this.scroll();
          //$LASTPOS=7000726;//user.DotConsole:726
          _this.cy=_this.row-1;
          
        }
        
      }
    },
    fiber$putchar :function _trc_DotConsole_f_putchar(_thread,ch) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      _thread.enter(function _trc_DotConsole_ent_putchar(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=7000552;//user.DotConsole:552
            if (!(ch!==10)) { __pc=2     ; break; }
            //$LASTPOS=7000575;//user.DotConsole:575
            _this.fiber$poke(_thread, _this.cx, _this.cy, ch);
            __pc=1;return;
          case 1:
            
            //$LASTPOS=7000599;//user.DotConsole:599
            _this.cx++;
          case 2     :
            
            //$LASTPOS=7000615;//user.DotConsole:615
            if (!(_this.cx>=_this.col||ch===10)) { __pc=5     ; break; }
            //$LASTPOS=7000649;//user.DotConsole:649
            _this.cx=0;
            //$LASTPOS=7000663;//user.DotConsole:663
            _this.cy++;
            //$LASTPOS=7000677;//user.DotConsole:677
            if (!(_this.cy>=_this.row)) { __pc=4     ; break; }
            //$LASTPOS=7000704;//user.DotConsole:704
            _this.fiber$scroll(_thread);
            __pc=3;return;
          case 3:
            
            //$LASTPOS=7000726;//user.DotConsole:726
            _this.cy=_this.row-1;
          case 4     :
            
          case 5     :
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    poke :function _trc_DotConsole_poke(cx,cy,ch) {
      "use strict";
      var _this=this;
      var ctx;
      var pImg;
      
      //$LASTPOS=7000779;//user.DotConsole:779
      if (_this.mat.get(cx,cy)===ch) {
        return _this;
      }
      //$LASTPOS=7000816;//user.DotConsole:816
      ctx = _this.context;
      
      //$LASTPOS=7000837;//user.DotConsole:837
      ctx.save();
      //$LASTPOS=7000853;//user.DotConsole:853
      ctx.textBaseline="top";
      //$LASTPOS=7000881;//user.DotConsole:881
      ctx.font=_this.size+"px Monospace";
      //$LASTPOS=7000915;//user.DotConsole:915
      ctx.beginPath();
      //$LASTPOS=7000936;//user.DotConsole:936
      ctx.moveTo(cx*_this.size,cy*_this.size);
      //$LASTPOS=7000969;//user.DotConsole:969
      ctx.lineTo((cx+1)*_this.size,cy*_this.size);
      //$LASTPOS=7001006;//user.DotConsole:1006
      ctx.lineTo((cx+1)*_this.size,(cy+1)*_this.size);
      //$LASTPOS=7001047;//user.DotConsole:1047
      ctx.lineTo(cx*_this.size,(cy+1)*_this.size);
      //$LASTPOS=7001084;//user.DotConsole:1084
      ctx.closePath();
      //$LASTPOS=7001105;//user.DotConsole:1105
      ctx.clip();
      //$LASTPOS=7001121;//user.DotConsole:1121
      ctx.clearRect(cx*_this.size,cy*_this.size,_this.size,_this.size);
      //$LASTPOS=7001167;//user.DotConsole:1167
      pImg = Tonyu.globals.$imageList[ch+_this.font];
      
      //$LASTPOS=7001201;//user.DotConsole:1201
      if (ch<128&&pImg) {
        //$LASTPOS=7001231;//user.DotConsole:1231
        ctx.drawImage(pImg.image,pImg.x,pImg.y,pImg.width,pImg.height,cx*_this.size,cy*_this.size,_this.size,_this.size);
        //$LASTPOS=7001354;//user.DotConsole:1354
        ctx.globalCompositeOperation="source-in";
        //$LASTPOS=7001404;//user.DotConsole:1404
        ctx.fill();
        
      } else {
        //$LASTPOS=7001437;//user.DotConsole:1437
        ctx.fillText(String.fromCharCode(ch),cx*_this.size,cy*_this.size);
        
      }
      //$LASTPOS=7001502;//user.DotConsole:1502
      _this.mat.set(cx,cy,ch);
      //$LASTPOS=7001525;//user.DotConsole:1525
      ctx.restore();
    },
    fiber$poke :function _trc_DotConsole_f_poke(_thread,cx,cy,ch) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var ctx;
      var pImg;
      
      //$LASTPOS=7000779;//user.DotConsole:779
      if (_this.mat.get(cx,cy)===ch) {
        _thread.retVal=_this;return;
        
      }
      //$LASTPOS=7000816;//user.DotConsole:816
      ctx = _this.context;
      
      //$LASTPOS=7000837;//user.DotConsole:837
      ctx.save();
      //$LASTPOS=7000853;//user.DotConsole:853
      ctx.textBaseline="top";
      //$LASTPOS=7000881;//user.DotConsole:881
      ctx.font=_this.size+"px Monospace";
      //$LASTPOS=7000915;//user.DotConsole:915
      ctx.beginPath();
      //$LASTPOS=7000936;//user.DotConsole:936
      ctx.moveTo(cx*_this.size,cy*_this.size);
      //$LASTPOS=7000969;//user.DotConsole:969
      ctx.lineTo((cx+1)*_this.size,cy*_this.size);
      //$LASTPOS=7001006;//user.DotConsole:1006
      ctx.lineTo((cx+1)*_this.size,(cy+1)*_this.size);
      //$LASTPOS=7001047;//user.DotConsole:1047
      ctx.lineTo(cx*_this.size,(cy+1)*_this.size);
      //$LASTPOS=7001084;//user.DotConsole:1084
      ctx.closePath();
      //$LASTPOS=7001105;//user.DotConsole:1105
      ctx.clip();
      //$LASTPOS=7001121;//user.DotConsole:1121
      ctx.clearRect(cx*_this.size,cy*_this.size,_this.size,_this.size);
      //$LASTPOS=7001167;//user.DotConsole:1167
      pImg = Tonyu.globals.$imageList[ch+_this.font];
      
      //$LASTPOS=7001201;//user.DotConsole:1201
      if (ch<128&&pImg) {
        //$LASTPOS=7001231;//user.DotConsole:1231
        ctx.drawImage(pImg.image,pImg.x,pImg.y,pImg.width,pImg.height,cx*_this.size,cy*_this.size,_this.size,_this.size);
        //$LASTPOS=7001354;//user.DotConsole:1354
        ctx.globalCompositeOperation="source-in";
        //$LASTPOS=7001404;//user.DotConsole:1404
        ctx.fill();
        
      } else {
        //$LASTPOS=7001437;//user.DotConsole:1437
        ctx.fillText(String.fromCharCode(ch),cx*_this.size,cy*_this.size);
        
      }
      //$LASTPOS=7001502;//user.DotConsole:1502
      _this.mat.set(cx,cy,ch);
      //$LASTPOS=7001525;//user.DotConsole:1525
      ctx.restore();
      
      _thread.retVal=_this;return;
    },
    peek :function _trc_DotConsole_peek(cx,cy) {
      "use strict";
      var _this=this;
      
      return _this.mat.get(cx,cy);
    },
    fiber$peek :function _trc_DotConsole_f_peek(_thread,cx,cy) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      _thread.retVal=_this.mat.get(cx,cy);return;
      
      
      _thread.retVal=_this;return;
    },
    scroll :function _trc_DotConsole_scroll() {
      "use strict";
      var _this=this;
      var nm;
      var x;
      var y;
      var c;
      var _it_19;
      
      //$LASTPOS=7001602;//user.DotConsole:1602
      nm = new Tonyu.classes.kernel.Matrix;
      
      //$LASTPOS=7001625;//user.DotConsole:1625
      _it_19=Tonyu.iterator(_this.mat,3);
      while(_it_19.next()) {
        x=_it_19[0];
        y=_it_19[1];
        c=_it_19[2];
        
        //$LASTPOS=7001658;//user.DotConsole:1658
        if (y>0) {
          //$LASTPOS=7001667;//user.DotConsole:1667
          nm.set(x,y-1,c);
        }
        
      }
      //$LASTPOS=7001694;//user.DotConsole:1694
      _this.mat=nm;
      //$LASTPOS=7001706;//user.DotConsole:1706
      _this.context.save();
      //$LASTPOS=7001726;//user.DotConsole:1726
      _this.context.globalCompositeOperation="copy";
      //$LASTPOS=7001771;//user.DotConsole:1771
      _this.context.drawImage(_this.image,0,_this.size,_this.width,_this.height-_this.size,0,0,_this.width,_this.height-_this.size);
      //$LASTPOS=7001848;//user.DotConsole:1848
      _this.context.restore();
    },
    fiber$scroll :function _trc_DotConsole_f_scroll(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var nm;
      var x;
      var y;
      var c;
      var _it_19;
      
      //$LASTPOS=7001602;//user.DotConsole:1602
      nm = new Tonyu.classes.kernel.Matrix;
      
      //$LASTPOS=7001625;//user.DotConsole:1625
      _it_19=Tonyu.iterator(_this.mat,3);
      while(_it_19.next()) {
        x=_it_19[0];
        y=_it_19[1];
        c=_it_19[2];
        
        //$LASTPOS=7001658;//user.DotConsole:1658
        if (y>0) {
          //$LASTPOS=7001667;//user.DotConsole:1667
          nm.set(x,y-1,c);
        }
        
      }
      //$LASTPOS=7001694;//user.DotConsole:1694
      _this.mat=nm;
      //$LASTPOS=7001706;//user.DotConsole:1706
      _this.context.save();
      //$LASTPOS=7001726;//user.DotConsole:1726
      _this.context.globalCompositeOperation="copy";
      //$LASTPOS=7001771;//user.DotConsole:1771
      _this.context.drawImage(_this.image,0,_this.size,_this.width,_this.height-_this.size,0,0,_this.width,_this.height-_this.size);
      //$LASTPOS=7001848;//user.DotConsole:1848
      _this.context.restore();
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"locate":{"nowait":false},"print":{"nowait":true},"putchar":{"nowait":false},"poke":{"nowait":false},"peek":{"nowait":false},"scroll":{"nowait":false}},"fields":{"size":{},"row":{},"col":{},"cx":{},"cy":{},"mat":{},"font":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Effect',
  shortName: 'Effect',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_Effect_main() {
      "use strict";
      var _this=this;
      
      
      //$LASTPOS=8000017;//user.Effect:17
      if (! _this.dst) {
        throw new Error("Effect: dst is null");
        
      }
      //$LASTPOS=8000067;//user.Effect:67
      _this.position.set(Tonyu.globals.$pzScreen.convert(_this.src,Tonyu.globals.$pzScreen.layer));
      //$LASTPOS=8000121;//user.Effect:121
      _this.alpha=200;
      //$LASTPOS=8000132;//user.Effect:132
      if (_this.dst instanceof Tonyu.classes.user.Player) {
        //$LASTPOS=8000157;//user.Effect:157
        _this.fillStyle=Tonyu.globals.$colors[_this.dst.col];
        //$LASTPOS=8000189;//user.Effect:189
        _this.radius=20;
        
      } else {
        //$LASTPOS=8000213;//user.Effect:213
        _this.fillStyle="red";
        //$LASTPOS=8000234;//user.Effect:234
        _this.text="×";
        //$LASTPOS=8000248;//user.Effect:248
        _this.size=64;
        
      }
      //$LASTPOS=8000259;//user.Effect:259
      _this.dp = new Tonyu.classes.kernel.Vec3(Tonyu.globals.$btScreen.convert(_this.dst,Tonyu.globals.$btScreen.layer));
      
      //$LASTPOS=8000318;//user.Effect:318
      _this.sp = _this.position.clone();
      
      //$LASTPOS=8000388;//user.Effect:388
      //$LASTPOS=8000392;//user.Effect:392
      _this.i = 0;
      for (; _this.i<=1 ; _this.i+=1/15) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=8000421;//user.Effect:421
          _this.position.set(_this.dp.mul(_this.i).add(_this.sp.mul(1-_this.i)));
          //$LASTPOS=8000467;//user.Effect:467
          _this.update();
        }
      }
      //$LASTPOS=8000479;//user.Effect:479
      _this.dst.incPow(_this.pow);
      //$LASTPOS=8000496;//user.Effect:496
      _this.die();
    },
    fiber$main :function _trc_Effect_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      //$LASTPOS=8000017;//user.Effect:17
      if (! _this.dst) {
        throw new Error("Effect: dst is null");
        
      }
      //$LASTPOS=8000067;//user.Effect:67
      _this.position.set(Tonyu.globals.$pzScreen.convert(_this.src,Tonyu.globals.$pzScreen.layer));
      //$LASTPOS=8000121;//user.Effect:121
      _this.alpha=200;
      //$LASTPOS=8000132;//user.Effect:132
      if (_this.dst instanceof Tonyu.classes.user.Player) {
        //$LASTPOS=8000157;//user.Effect:157
        _this.fillStyle=Tonyu.globals.$colors[_this.dst.col];
        //$LASTPOS=8000189;//user.Effect:189
        _this.radius=20;
        
      } else {
        //$LASTPOS=8000213;//user.Effect:213
        _this.fillStyle="red";
        //$LASTPOS=8000234;//user.Effect:234
        _this.text="×";
        //$LASTPOS=8000248;//user.Effect:248
        _this.size=64;
        
      }
      //$LASTPOS=8000259;//user.Effect:259
      _this.dp = new Tonyu.classes.kernel.Vec3(Tonyu.globals.$btScreen.convert(_this.dst,Tonyu.globals.$btScreen.layer));
      
      //$LASTPOS=8000318;//user.Effect:318
      _this.sp = _this.position.clone();
      
      
      _thread.enter(function _trc_Effect_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=8000388;//user.Effect:388
            //$LASTPOS=8000392;//user.Effect:392
            _this.i = 0;
            
          case 1:
            if (!(_this.i<=1)) { __pc=4     ; break; }
            //$LASTPOS=8000421;//user.Effect:421
            _this.position.set(_this.dp.mul(_this.i).add(_this.sp.mul(1-_this.i)));
            //$LASTPOS=8000467;//user.Effect:467
            _this.fiber$update(_thread);
            __pc=2;return;
          case 2:
            
          case 3     :
            _this.i+=1/15;
            __pc=1;break;
          case 4     :
            
            //$LASTPOS=8000479;//user.Effect:479
            _this.dst.incPow(_this.pow);
            //$LASTPOS=8000496;//user.Effect:496
            _this.die();
            _thread.exit(_this);return;
          }
        }
      });
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"src":{},"dst":{},"pow":{},"dp":{},"sp":{},"i":{}}}
});
Tonyu.klass.define({
  fullName: 'user.EParty',
  shortName: 'EParty',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_EParty_main() {
      "use strict";
      var _this=this;
      
      
      //$LASTPOS=9000020;//user.EParty:20
      _this.p=1;
      //$LASTPOS=9000025;//user.EParty:25
      _this.emax = 12;
      
      //$LASTPOS=9000038;//user.EParty:38
      _this.maxe=_this.maxe||3;
      //$LASTPOS=9000065;//user.EParty:65
      _this.pitch=_this.scr.width/_this.maxe;
      //$LASTPOS=9000087;//user.EParty:87
      _this.wave = 10*Tonyu.globals.$level-10;
      
      //$LASTPOS=9000110;//user.EParty:110
      while (true) {
        Tonyu.checkLoop();
        //$LASTPOS=9000128;//user.EParty:128
        if (_this.count()==0) {
          //$LASTPOS=9000154;//user.EParty:154
          _this.wave++;
          //$LASTPOS=9000170;//user.EParty:170
          Tonyu.globals.$console.locate(3,3);
          //$LASTPOS=9000200;//user.EParty:200
          Tonyu.globals.$console.print("WAVE "+_this.wave);
          //$LASTPOS=9000238;//user.EParty:238
          _this.updateEx(30);
          //$LASTPOS=9000268;//user.EParty:268
          Tonyu.globals.$console.locate(3,3);
          //$LASTPOS=9000298;//user.EParty:298
          Tonyu.globals.$console.print("           ");
          //$LASTPOS=9000337;//user.EParty:337
          _this.addAll();
          
        }
        //$LASTPOS=9000357;//user.EParty:357
        _this.updateEx(30);
        
      }
    },
    fiber$main :function _trc_EParty_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      //$LASTPOS=9000020;//user.EParty:20
      _this.p=1;
      //$LASTPOS=9000025;//user.EParty:25
      _this.emax = 12;
      
      //$LASTPOS=9000038;//user.EParty:38
      _this.maxe=_this.maxe||3;
      //$LASTPOS=9000065;//user.EParty:65
      _this.pitch=_this.scr.width/_this.maxe;
      //$LASTPOS=9000087;//user.EParty:87
      _this.wave = 10*Tonyu.globals.$level-10;
      
      
      _thread.enter(function _trc_EParty_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=9000110;//user.EParty:110
          case 1:
            //$LASTPOS=9000128;//user.EParty:128
            if (!(_this.count()==0)) { __pc=4     ; break; }
            //$LASTPOS=9000154;//user.EParty:154
            _this.wave++;
            //$LASTPOS=9000170;//user.EParty:170
            Tonyu.globals.$console.locate(3,3);
            //$LASTPOS=9000200;//user.EParty:200
            Tonyu.globals.$console.print("WAVE "+_this.wave);
            //$LASTPOS=9000238;//user.EParty:238
            _this.fiber$updateEx(_thread, 30);
            __pc=2;return;
          case 2:
            
            //$LASTPOS=9000268;//user.EParty:268
            Tonyu.globals.$console.locate(3,3);
            //$LASTPOS=9000298;//user.EParty:298
            Tonyu.globals.$console.print("           ");
            //$LASTPOS=9000337;//user.EParty:337
            _this.fiber$addAll(_thread);
            __pc=3;return;
          case 3:
            
          case 4     :
            
            //$LASTPOS=9000357;//user.EParty:357
            _this.fiber$updateEx(_thread, 30);
            __pc=5;return;
          case 5:
            
            __pc=1;break;
          case 6     :
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    add :function _trc_EParty_add(c) {
      "use strict";
      var _this=this;
      var rank;
      
      //$LASTPOS=9000388;//user.EParty:388
      rank = _this.rnd(_this.clamp(_this.wave,0,_this.emax));
      
      //$LASTPOS=9000426;//user.EParty:426
      new Tonyu.classes.user.Enemy({lifeMax: 15+rank*5+_this.wave*3,x: (c+0.5)*_this.pitch,y: 32,p: Tonyu.globals.$pat_enemy1+rank,fillStyle: Tonyu.globals.$colors[c],layer: _this.layer});
    },
    fiber$add :function _trc_EParty_f_add(_thread,c) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var rank;
      
      //$LASTPOS=9000388;//user.EParty:388
      rank = _this.rnd(_this.clamp(_this.wave,0,_this.emax));
      
      //$LASTPOS=9000426;//user.EParty:426
      new Tonyu.classes.user.Enemy({lifeMax: 15+rank*5+_this.wave*3,x: (c+0.5)*_this.pitch,y: 32,p: Tonyu.globals.$pat_enemy1+rank,fillStyle: Tonyu.globals.$colors[c],layer: _this.layer});
      
      _thread.retVal=_this;return;
    },
    addAll :function _trc_EParty_addAll() {
      "use strict";
      var _this=this;
      var i;
      
      //$LASTPOS=9000603;//user.EParty:603
      //$LASTPOS=9000608;//user.EParty:608
      i = 0;
      for (; i<_this.maxe ; i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=9000638;//user.EParty:638
          _this.add(i);
        }
      }
    },
    fiber$addAll :function _trc_EParty_f_addAll(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var i;
      
      
      _thread.enter(function _trc_EParty_ent_addAll(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=9000603;//user.EParty:603
            //$LASTPOS=9000608;//user.EParty:608
            i = 0;
            
          case 1:
            if (!(i<_this.maxe)) { __pc=4     ; break; }
            //$LASTPOS=9000638;//user.EParty:638
            _this.fiber$add(_thread, i);
            __pc=2;return;
          case 2:
            
          case 3     :
            i++;
            __pc=1;break;
          case 4     :
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    count :function _trc_EParty_count() {
      "use strict";
      var _this=this;
      
      return _this.all(Tonyu.classes.user.Enemy).length;
    },
    fiber$count :function _trc_EParty_f_count(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      _thread.retVal=_this.all(Tonyu.classes.user.Enemy).length;return;
      
      
      _thread.retVal=_this;return;
    },
    random :function _trc_EParty_random() {
      "use strict";
      var _this=this;
      
      return _this.all(Tonyu.classes.user.Enemy).random();
    },
    fiber$random :function _trc_EParty_f_random(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      _thread.retVal=_this.all(Tonyu.classes.user.Enemy).random();return;
      
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"add":{"nowait":false},"addAll":{"nowait":false},"count":{"nowait":false},"random":{"nowait":false}},"fields":{"pitch":{},"scr":{},"maxe":{},"emax":{},"wave":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_Main_main() {
      "use strict";
      var _this=this;
      
      
      //$LASTPOS=10000017;//user.Main:17
      Tonyu.globals.$colors=["#0af","#e00","#ee0","#0d6","#a0f"];
      //$LASTPOS=10000063;//user.Main:63
      Tonyu.globals.$colorc=5;
      //$LASTPOS=10000074;//user.Main:74
      Tonyu.globals.$r=5;
      //$LASTPOS=10000079;//user.Main:79
      Tonyu.globals.$c=6;
      //$LASTPOS=10000115;//user.Main:115
      Tonyu.globals.$Screen.resize(Tonyu.globals.$c*32,Tonyu.globals.$r*64);
      //$LASTPOS=10000144;//user.Main:144
      _this.m=new Tonyu.classes.user.MakePat;
      //$LASTPOS=10000159;//user.Main:159
      _this.waitEvent(_this.m,"die");
      //$LASTPOS=10000260;//user.Main:260
      Tonyu.globals.$map=new Tonyu.classes.user.BG(Tonyu.globals.$pground);
      //$LASTPOS=10000284;//user.Main:284
      Tonyu.globals.$btScreen=new Tonyu.classes.user.BtScreen({x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight/4,width: Tonyu.globals.$screenWidth/2,height: Tonyu.globals.$screenHeight/4,scaleX: 2});
      //$LASTPOS=10000398;//user.Main:398
      Tonyu.globals.$btScreen.setBGColor(new Tonyu.classes.kernel.Color(0,0,0,128));
      //$LASTPOS=10000442;//user.Main:442
      Tonyu.globals.$btScreen.clearBG=true;
      //$LASTPOS=10000467;//user.Main:467
      Tonyu.globals.$pzScreen=new Tonyu.classes.user.PzScreen({x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight-32*(Tonyu.globals.$r/2),width: Tonyu.globals.$c*32,height: 32*Tonyu.globals.$r});
      //$LASTPOS=10000561;//user.Main:561
      Tonyu.globals.$pzScreen.setBGColor(new Tonyu.classes.kernel.Color(0,0,0,64));
      //$LASTPOS=10000604;//user.Main:604
      Tonyu.globals.$pzScreen.clearBG=true;
      //$LASTPOS=10000629;//user.Main:629
      //$LASTPOS=10000634;//user.Main:634
      _this.i=Tonyu.globals.$r-1;for (; _this.i>=0 ; _this.i--) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=10000657;//user.Main:657
          //$LASTPOS=10000662;//user.Main:662
          _this.j=0;for (; _this.j<Tonyu.globals.$c ; _this.j++) {
            Tonyu.checkLoop();
            {
              //$LASTPOS=10000686;//user.Main:686
              Tonyu.globals.$pzScreen.genDBall(_this.j,_this.i-Tonyu.globals.$r,Tonyu.globals.$pat_iroball+_this.rnd(25));
            }
          }
        }
      }
      //$LASTPOS=10000752;//user.Main:752
      while (true) {
        Tonyu.checkLoop();
        //$LASTPOS=10000801;//user.Main:801
        if (_this.chain) {
          //$LASTPOS=10000822;//user.Main:822
          if (_this.chain.isDead()) {
            //$LASTPOS=10000842;//user.Main:842
            _this.chain=null;
          }
          
        } else {
          //$LASTPOS=10000865;//user.Main:865
          if (Tonyu.globals.$touches[0].touched==1) {
            //$LASTPOS=10000903;//user.Main:903
            _this.g = Tonyu.globals.$pzScreen.grid(Tonyu.globals.$touches[0]);
            
            //$LASTPOS=10000946;//user.Main:946
            _this.b = Tonyu.globals.$pzScreen.getSBall(_this.g.gx,_this.g.gy);
            
            //$LASTPOS=10000991;//user.Main:991
            if (_this.b) {
              //$LASTPOS=10001012;//user.Main:1012
              _this.chain=new Tonyu.classes.user.Chain({gx: _this.g.gx,gy: _this.g.gy,layer: Tonyu.globals.$pzScreen.ballLayer});
              
            }
            
          }
        }
        //$LASTPOS=10001404;//user.Main:1404
        _this.update();
        
      }
    },
    fiber$main :function _trc_Main_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      //$LASTPOS=10000017;//user.Main:17
      Tonyu.globals.$colors=["#0af","#e00","#ee0","#0d6","#a0f"];
      //$LASTPOS=10000063;//user.Main:63
      Tonyu.globals.$colorc=5;
      //$LASTPOS=10000074;//user.Main:74
      Tonyu.globals.$r=5;
      //$LASTPOS=10000079;//user.Main:79
      Tonyu.globals.$c=6;
      //$LASTPOS=10000115;//user.Main:115
      Tonyu.globals.$Screen.resize(Tonyu.globals.$c*32,Tonyu.globals.$r*64);
      //$LASTPOS=10000144;//user.Main:144
      _this.m=new Tonyu.classes.user.MakePat;
      
      _thread.enter(function _trc_Main_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=10000159;//user.Main:159
            _this.fiber$waitEvent(_thread, _this.m, "die");
            __pc=1;return;
          case 1:
            
            //$LASTPOS=10000260;//user.Main:260
            Tonyu.globals.$map=new Tonyu.classes.user.BG(Tonyu.globals.$pground);
            //$LASTPOS=10000284;//user.Main:284
            Tonyu.globals.$btScreen=new Tonyu.classes.user.BtScreen({x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight/4,width: Tonyu.globals.$screenWidth/2,height: Tonyu.globals.$screenHeight/4,scaleX: 2});
            //$LASTPOS=10000398;//user.Main:398
            Tonyu.globals.$btScreen.setBGColor(new Tonyu.classes.kernel.Color(0,0,0,128));
            //$LASTPOS=10000442;//user.Main:442
            Tonyu.globals.$btScreen.clearBG=true;
            //$LASTPOS=10000467;//user.Main:467
            Tonyu.globals.$pzScreen=new Tonyu.classes.user.PzScreen({x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight-32*(Tonyu.globals.$r/2),width: Tonyu.globals.$c*32,height: 32*Tonyu.globals.$r});
            //$LASTPOS=10000561;//user.Main:561
            Tonyu.globals.$pzScreen.setBGColor(new Tonyu.classes.kernel.Color(0,0,0,64));
            //$LASTPOS=10000604;//user.Main:604
            Tonyu.globals.$pzScreen.clearBG=true;
            //$LASTPOS=10000629;//user.Main:629
            //$LASTPOS=10000634;//user.Main:634
            _this.i=Tonyu.globals.$r-1;for (; _this.i>=0 ; _this.i--) {
              Tonyu.checkLoop();
              {
                //$LASTPOS=10000657;//user.Main:657
                //$LASTPOS=10000662;//user.Main:662
                _this.j=0;for (; _this.j<Tonyu.globals.$c ; _this.j++) {
                  Tonyu.checkLoop();
                  {
                    //$LASTPOS=10000686;//user.Main:686
                    Tonyu.globals.$pzScreen.genDBall(_this.j,_this.i-Tonyu.globals.$r,Tonyu.globals.$pat_iroball+_this.rnd(25));
                  }
                }
              }
            }
            //$LASTPOS=10000752;//user.Main:752
          case 2:
            //$LASTPOS=10000801;//user.Main:801
            if (_this.chain) {
              //$LASTPOS=10000822;//user.Main:822
              if (_this.chain.isDead()) {
                //$LASTPOS=10000842;//user.Main:842
                _this.chain=null;
              }
              
            } else {
              //$LASTPOS=10000865;//user.Main:865
              if (Tonyu.globals.$touches[0].touched==1) {
                //$LASTPOS=10000903;//user.Main:903
                _this.g = Tonyu.globals.$pzScreen.grid(Tonyu.globals.$touches[0]);
                
                //$LASTPOS=10000946;//user.Main:946
                _this.b = Tonyu.globals.$pzScreen.getSBall(_this.g.gx,_this.g.gy);
                
                //$LASTPOS=10000991;//user.Main:991
                if (_this.b) {
                  //$LASTPOS=10001012;//user.Main:1012
                  _this.chain=new Tonyu.classes.user.Chain({gx: _this.g.gx,gy: _this.g.gy,layer: Tonyu.globals.$pzScreen.ballLayer});
                  
                }
                
              }
            }
            //$LASTPOS=10001404;//user.Main:1404
            _this.fiber$update(_thread);
            __pc=3;return;
          case 3:
            
            __pc=2;break;
          case 4     :
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"m":{},"i":{},"j":{},"chain":{},"g":{},"b":{}}}
});
Tonyu.klass.define({
  fullName: 'user.MakePat',
  shortName: 'MakePat',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_MakePat_main() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=11000000;//user.MakePat:0
      _this.x=_this.y=0;
      //$LASTPOS=11000006;//user.MakePat:6
      _this.p=- 1;
      //$LASTPOS=11000059;//user.MakePat:59
      _this.pa = new Tonyu.classes.kernel.Panel({width: 64,height: 32,alpha: 0});
      
      //$LASTPOS=11000105;//user.MakePat:105
      _this.drawLight(_this.x,_this.y);
      //$LASTPOS=11000121;//user.MakePat:121
      Tonyu.globals.$pshade=_this.pa.addPattern(_this.x,_this.y,32,32);
      //$LASTPOS=11000155;//user.MakePat:155
      _this.update();
      //$LASTPOS=11000165;//user.MakePat:165
      _this.x+=32;
      //$LASTPOS=11000172;//user.MakePat:172
      _this.drawGround(_this.x,_this.y);
      //$LASTPOS=11000189;//user.MakePat:189
      Tonyu.globals.$pground=_this.pa.addPattern(_this.x,_this.y,32,32);
      //$LASTPOS=11000224;//user.MakePat:224
      _this.die();
    },
    fiber$main :function _trc_MakePat_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=11000000;//user.MakePat:0
      _this.x=_this.y=0;
      //$LASTPOS=11000006;//user.MakePat:6
      _this.p=- 1;
      //$LASTPOS=11000059;//user.MakePat:59
      _this.pa = new Tonyu.classes.kernel.Panel({width: 64,height: 32,alpha: 0});
      
      
      _thread.enter(function _trc_MakePat_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=11000105;//user.MakePat:105
            _this.fiber$drawLight(_thread, _this.x, _this.y);
            __pc=1;return;
          case 1:
            
            //$LASTPOS=11000121;//user.MakePat:121
            Tonyu.globals.$pshade=_this.pa.addPattern(_this.x,_this.y,32,32);
            //$LASTPOS=11000155;//user.MakePat:155
            _this.fiber$update(_thread);
            __pc=2;return;
          case 2:
            
            //$LASTPOS=11000165;//user.MakePat:165
            _this.x+=32;
            //$LASTPOS=11000172;//user.MakePat:172
            _this.fiber$drawGround(_thread, _this.x, _this.y);
            __pc=3;return;
          case 3:
            
            //$LASTPOS=11000189;//user.MakePat:189
            Tonyu.globals.$pground=_this.pa.addPattern(_this.x,_this.y,32,32);
            //$LASTPOS=11000224;//user.MakePat:224
            _this.die();
            _thread.exit(_this);return;
          }
        }
      });
    },
    drawLight :function _trc_MakePat_drawLight(bx,by) {
      "use strict";
      var _this=this;
      var li;
      var ce;
      
      //$LASTPOS=11000357;//user.MakePat:357
      li = new Tonyu.classes.kernel.Vec3(8,8);
      ce = new Tonyu.classes.kernel.Vec3(16,16);
      
      //$LASTPOS=11000403;//user.MakePat:403
      _this.pa.replaceColor(bx,by,32,32,(function anonymous_433(c,x,y) {
        var p;
        var d;
        var cd;
        
        //$LASTPOS=11000452;//user.MakePat:452
        x-=bx;
        //$LASTPOS=11000458;//user.MakePat:458
        y-=by;
        //$LASTPOS=11000473;//user.MakePat:473
        p = new Tonyu.classes.kernel.Vec3(x,y);
        
        //$LASTPOS=11000502;//user.MakePat:502
        d = p.sub(li).length;
        
        //$LASTPOS=11000534;//user.MakePat:534
        if (d<5) {
          //$LASTPOS=11000543;//user.MakePat:543
          c.setHSLA(0,0,1,255-d*30);
        }
        //$LASTPOS=11000607;//user.MakePat:607
        cd = p.sub(ce).length;
        
        //$LASTPOS=11000640;//user.MakePat:640
        if (d>15&&cd<16) {
          //$LASTPOS=11000673;//user.MakePat:673
          c.setHSLA(0,0,0,(d-15)*20);
          
        }
      }));
    },
    fiber$drawLight :function _trc_MakePat_f_drawLight(_thread,bx,by) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var li;
      var ce;
      
      //$LASTPOS=11000357;//user.MakePat:357
      li = new Tonyu.classes.kernel.Vec3(8,8);
      ce = new Tonyu.classes.kernel.Vec3(16,16);
      
      //$LASTPOS=11000403;//user.MakePat:403
      _this.pa.replaceColor(bx,by,32,32,(function anonymous_433(c,x,y) {
        var p;
        var d;
        var cd;
        
        //$LASTPOS=11000452;//user.MakePat:452
        x-=bx;
        //$LASTPOS=11000458;//user.MakePat:458
        y-=by;
        //$LASTPOS=11000473;//user.MakePat:473
        p = new Tonyu.classes.kernel.Vec3(x,y);
        
        //$LASTPOS=11000502;//user.MakePat:502
        d = p.sub(li).length;
        
        //$LASTPOS=11000534;//user.MakePat:534
        if (d<5) {
          //$LASTPOS=11000543;//user.MakePat:543
          c.setHSLA(0,0,1,255-d*30);
        }
        //$LASTPOS=11000607;//user.MakePat:607
        cd = p.sub(ce).length;
        
        //$LASTPOS=11000640;//user.MakePat:640
        if (d>15&&cd<16) {
          //$LASTPOS=11000673;//user.MakePat:673
          c.setHSLA(0,0,0,(d-15)*20);
          
        }
      }));
      
      _thread.retVal=_this;return;
    },
    drawGround :function _trc_MakePat_drawGround(bx,by) {
      "use strict";
      var _this=this;
      var i;
      
      //$LASTPOS=11000898;//user.MakePat:898
      _this.pa.fillStyle="#0d0";
      //$LASTPOS=11000923;//user.MakePat:923
      _this.pa.fillRect(bx,by,32,32);
      //$LASTPOS=11000953;//user.MakePat:953
      _this.pa.fillStyle="lime";
      //$LASTPOS=11000978;//user.MakePat:978
      //$LASTPOS=11000982;//user.MakePat:982
      i = 0;
      for (; i<50 ; i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=11001010;//user.MakePat:1010
          _this.pa.fillRect(bx+_this.rnd(32),by+_this.rnd(32),1,1);
        }
      }
    },
    fiber$drawGround :function _trc_MakePat_f_drawGround(_thread,bx,by) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var i;
      
      //$LASTPOS=11000898;//user.MakePat:898
      _this.pa.fillStyle="#0d0";
      //$LASTPOS=11000923;//user.MakePat:923
      _this.pa.fillRect(bx,by,32,32);
      //$LASTPOS=11000953;//user.MakePat:953
      _this.pa.fillStyle="lime";
      //$LASTPOS=11000978;//user.MakePat:978
      //$LASTPOS=11000982;//user.MakePat:982
      i = 0;
      for (; i<50 ; i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=11001010;//user.MakePat:1010
          _this.pa.fillRect(bx+_this.rnd(32),by+_this.rnd(32),1,1);
        }
      }
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"drawLight":{"nowait":false},"drawGround":{"nowait":false}},"fields":{"pa":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Member',
  shortName: 'Member',
  namespace: 'user',
  superclass: Tonyu.classes.user.ColorSprite,
  includes: [],
  methods: {
    main :function _trc_Member_main() {
      "use strict";
      var _this=this;
      
      
      
    },
    fiber$main :function _trc_Member_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      
      
      _thread.retVal=_this;return;
    },
    initialize :function _trc_Member_initialize(p) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=12000095;//user.Member:95
      Tonyu.classes.user.ColorSprite.apply( _this, [p]);
      //$LASTPOS=12000109;//user.Member:109
      _this.lifeMax=_this.lifeMax||20;
      //$LASTPOS=12000134;//user.Member:134
      _this.life=_this.lifeMax;
      //$LASTPOS=12000152;//user.Member:152
      _this.skillMax=_this.skillMax||20;
      //$LASTPOS=12000179;//user.Member:179
      _this.skill=0;
      //$LASTPOS=12000192;//user.Member:192
      _this.quake=0;
      //$LASTPOS=12000205;//user.Member:205
      _this.op=_this.position.clone();
    },
    draw :function _trc_Member_draw(ctx) {
      "use strict";
      var _this=this;
      var sx;
      var sy;
      var t;
      var len;
      var ll;
      var sl;
      
      //$LASTPOS=12000244;//user.Member:244
      sx = _this.x;
      sy = _this.y;
      
      //$LASTPOS=12000263;//user.Member:263
      _this.x+=_this.rndFloat(- 2,2)*_this.quake;
      //$LASTPOS=12000292;//user.Member:292
      _this.y+=_this.rndFloat(- 2,2)*_this.quake;
      //$LASTPOS=12000321;//user.Member:321
      Tonyu.classes.user.ColorSprite.prototype.draw.apply( _this, [ctx]);
      //$LASTPOS=12000342;//user.Member:342
      _this.x=sx;
      //$LASTPOS=12000347;//user.Member:347
      _this.y=sy;
      //$LASTPOS=12000357;//user.Member:357
      if (_this.life<=0) {
        return _this;
      }
      //$LASTPOS=12000382;//user.Member:382
      ctx.globalAlpha=1;
      //$LASTPOS=12000405;//user.Member:405
      ctx.lineWidth=2;
      //$LASTPOS=12000465;//user.Member:465
      t = new Tonyu.classes.user.Turtle(ctx,_this.floor(_this.x-8),_this.floor(_this.y-10));
      
      //$LASTPOS=12000515;//user.Member:515
      len = 16;
      
      //$LASTPOS=12000531;//user.Member:531
      ll = _this.floor(_this.life/_this.lifeMax*len);
      
      //$LASTPOS=12000567;//user.Member:567
      t.strokeStyle="lime";
      //$LASTPOS=12000593;//user.Member:593
      t.lineBy(ll,0);
      //$LASTPOS=12000613;//user.Member:613
      t.strokeStyle="red";
      //$LASTPOS=12000638;//user.Member:638
      t.lineBy(len-ll,0);
      //$LASTPOS=12000667;//user.Member:667
      t.moveBy(- len,- 4);
      //$LASTPOS=12000690;//user.Member:690
      sl = _this.floor(_this.skill/_this.skillMax*len);
      
      //$LASTPOS=12000728;//user.Member:728
      t.strokeStyle="cyan";
      //$LASTPOS=12000754;//user.Member:754
      t.lineBy(sl,0);
    },
    checkLife :function _trc_Member_checkLife() {
      "use strict";
      var _this=this;
      var i;
      
      //$LASTPOS=12000849;//user.Member:849
      if (_this.life<=0) {
        //$LASTPOS=12000872;//user.Member:872
        //$LASTPOS=12000877;//user.Member:877
        i = 0;
        for (; i<50 ; i++) {
          Tonyu.checkLoop();
          {
            //$LASTPOS=12000896;//user.Member:896
            _this.alpha-=5;
            //$LASTPOS=12000905;//user.Member:905
            _this.update();
          }
        }
        //$LASTPOS=12000924;//user.Member:924
        _this.die();
        
      }
    },
    fiber$checkLife :function _trc_Member_f_checkLife(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var i;
      
      
      _thread.enter(function _trc_Member_ent_checkLife(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=12000849;//user.Member:849
            if (!(_this.life<=0)) { __pc=5     ; break; }
            //$LASTPOS=12000872;//user.Member:872
            //$LASTPOS=12000877;//user.Member:877
            i = 0;
            
          case 1:
            if (!(i<50)) { __pc=4     ; break; }
            //$LASTPOS=12000896;//user.Member:896
            _this.alpha-=5;
            //$LASTPOS=12000905;//user.Member:905
            _this.fiber$update(_thread);
            __pc=2;return;
          case 2:
            
          case 3     :
            i++;
            __pc=1;break;
          case 4     :
            
            //$LASTPOS=12000924;//user.Member:924
            _this.die();
          case 5     :
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    attack :function _trc_Member_attack(tg) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=12000957;//user.Member:957
      if (! tg) {
        return _this;
      }
      //$LASTPOS=12000978;//user.Member:978
      while (_this.dist(tg)>8) {
        Tonyu.checkLoop();
        //$LASTPOS=12001006;//user.Member:1006
        _this.position.addX(tg.position.sub(_this.position).normalizeX(4));
        //$LASTPOS=12001071;//user.Member:1071
        _this.checkLife();
        //$LASTPOS=12001092;//user.Member:1092
        _this.update();
        
      }
      //$LASTPOS=12001112;//user.Member:1112
      tg.life-=_this.pow;
      //$LASTPOS=12001135;//user.Member:1135
      while (_this.dist(_this.op)>4) {
        Tonyu.checkLoop();
        //$LASTPOS=12001163;//user.Member:1163
        _this.position.addX(_this.op.sub(_this.position).normalizeX(4));
        //$LASTPOS=12001219;//user.Member:1219
        _this.checkLife();
        //$LASTPOS=12001240;//user.Member:1240
        _this.update();
        
      }
      //$LASTPOS=12001260;//user.Member:1260
      _this.position.set(_this.op);
      //$LASTPOS=12001282;//user.Member:1282
      _this.pow=0;
    },
    fiber$attack :function _trc_Member_f_attack(_thread,tg) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=12000957;//user.Member:957
      if (! tg) {
        _thread.retVal=_this;return;
        
      }
      
      _thread.enter(function _trc_Member_ent_attack(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=12000978;//user.Member:978
          case 1:
            if (!(_this.dist(tg)>8)) { __pc=4     ; break; }
            //$LASTPOS=12001006;//user.Member:1006
            _this.position.addX(tg.position.sub(_this.position).normalizeX(4));
            //$LASTPOS=12001071;//user.Member:1071
            _this.fiber$checkLife(_thread);
            __pc=2;return;
          case 2:
            
            //$LASTPOS=12001092;//user.Member:1092
            _this.fiber$update(_thread);
            __pc=3;return;
          case 3:
            
            __pc=1;break;
          case 4     :
            
            //$LASTPOS=12001112;//user.Member:1112
            tg.life-=_this.pow;
            //$LASTPOS=12001135;//user.Member:1135
          case 5:
            if (!(_this.dist(_this.op)>4)) { __pc=8     ; break; }
            //$LASTPOS=12001163;//user.Member:1163
            _this.position.addX(_this.op.sub(_this.position).normalizeX(4));
            //$LASTPOS=12001219;//user.Member:1219
            _this.fiber$checkLife(_thread);
            __pc=6;return;
          case 6:
            
            //$LASTPOS=12001240;//user.Member:1240
            _this.fiber$update(_thread);
            __pc=7;return;
          case 7:
            
            __pc=5;break;
          case 8     :
            
            //$LASTPOS=12001260;//user.Member:1260
            _this.position.set(_this.op);
            //$LASTPOS=12001282;//user.Member:1282
            _this.pow=0;
            _thread.exit(_this);return;
          }
        }
      });
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"draw":{"nowait":true},"checkLife":{"nowait":false},"attack":{"nowait":false}},"fields":{"life":{},"lifeMax":{},"skill":{},"skillMax":{},"pow":{},"op":{},"quake":{},"ap":{},"dp":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Menu',
  shortName: 'Menu',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_Menu_main() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=13000001;//user.Menu:1
      //$LASTPOS=13000006;//user.Menu:6
      _this.i = 1;
      for (; _this.i<=5 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=13000030;//user.Menu:30
          new Tonyu.classes.kernel.Button({text: "ダンジョン"+_this.i,top: _this.i*50+100,level: _this.i,onClick: Tonyu.bindFunc(_this,_this.go)});
        }
      }
    },
    fiber$main :function _trc_Menu_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=13000001;//user.Menu:1
      //$LASTPOS=13000006;//user.Menu:6
      _this.i = 1;
      for (; _this.i<=5 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=13000030;//user.Menu:30
          new Tonyu.classes.kernel.Button({text: "ダンジョン"+_this.i,top: _this.i*50+100,level: _this.i,onClick: Tonyu.bindFunc(_this,_this.go)});
        }
      }
      
      _thread.retVal=_this;return;
    },
    go :function _trc_Menu_go(c) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=13000110;//user.Menu:110
      Tonyu.globals.$level=c.level;
      //$LASTPOS=13000130;//user.Menu:130
      new Tonyu.classes.kernel.FadeEffect({type: "out",page: Tonyu.classes.user.Main});
    },
    fiber$go :function _trc_Menu_f_go(_thread,c) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=13000110;//user.Menu:110
      Tonyu.globals.$level=c.level;
      //$LASTPOS=13000130;//user.Menu:130
      new Tonyu.classes.kernel.FadeEffect({type: "out",page: Tonyu.classes.user.Main});
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"go":{"nowait":false}},"fields":{"i":{}}}
});
Tonyu.klass.define({
  fullName: 'user.MkPlPat',
  shortName: 'MkPlPat',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_MkPlPat_main() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=14000000;//user.MkPlPat:0
      Tonyu.globals.$Screen.setBGColor("#aaa");
      //$LASTPOS=14000028;//user.MkPlPat:28
      _this.panel = new Tonyu.classes.kernel.Panel({x: 100,y: 100,width: 16*9,height: 16});
      
      //$LASTPOS=14000084;//user.MkPlPat:84
      _this.p=Tonyu.globals.$pat_mgoku+5;
      //$LASTPOS=14000100;//user.MkPlPat:100
      //$LASTPOS=14000105;//user.MkPlPat:105
      _this.i = 0;
      for (; _this.i<9 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=14000128;//user.MkPlPat:128
          _this.panel.drawSprite(16*_this.i+8,8,_this.p);
          //$LASTPOS=14000162;//user.MkPlPat:162
          _this.p++;
        }
      }
      //$LASTPOS=14000169;//user.MkPlPat:169
      _this.panel.replaceColor(0,0,9*16,16,(function anonymous_201(c) {
        
        //$LASTPOS=14000212;//user.MkPlPat:212
        if (c.distRGBA(new Tonyu.classes.kernel.Color(0,0,0))<0.1) {
          //$LASTPOS=14000260;//user.MkPlPat:260
          c.setRGBA(0,0,0,0);
          
        }
      }));
      //$LASTPOS=14000289;//user.MkPlPat:289
      _this.panel.save("player.png");
    },
    fiber$main :function _trc_MkPlPat_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=14000000;//user.MkPlPat:0
      Tonyu.globals.$Screen.setBGColor("#aaa");
      //$LASTPOS=14000028;//user.MkPlPat:28
      _this.panel = new Tonyu.classes.kernel.Panel({x: 100,y: 100,width: 16*9,height: 16});
      
      //$LASTPOS=14000084;//user.MkPlPat:84
      _this.p=Tonyu.globals.$pat_mgoku+5;
      //$LASTPOS=14000100;//user.MkPlPat:100
      //$LASTPOS=14000105;//user.MkPlPat:105
      _this.i = 0;
      for (; _this.i<9 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=14000128;//user.MkPlPat:128
          _this.panel.drawSprite(16*_this.i+8,8,_this.p);
          //$LASTPOS=14000162;//user.MkPlPat:162
          _this.p++;
        }
      }
      //$LASTPOS=14000169;//user.MkPlPat:169
      _this.panel.replaceColor(0,0,9*16,16,(function anonymous_201(c) {
        
        //$LASTPOS=14000212;//user.MkPlPat:212
        if (c.distRGBA(new Tonyu.classes.kernel.Color(0,0,0))<0.1) {
          //$LASTPOS=14000260;//user.MkPlPat:260
          c.setRGBA(0,0,0,0);
          
        }
      }));
      //$LASTPOS=14000289;//user.MkPlPat:289
      _this.panel.save("player.png");
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"panel":{},"i":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Player',
  shortName: 'Player',
  namespace: 'user',
  superclass: Tonyu.classes.user.Member,
  includes: [],
  methods: {
    main :function _trc_Player_main() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=15000016;//user.Player:16
      _this.pow = 0;
      _this.powc = 0;
      
      //$LASTPOS=15000060;//user.Player:60
      while (true) {
        Tonyu.checkLoop();
        //$LASTPOS=15000078;//user.Player:78
        if (_this.pow>0) {
          //$LASTPOS=15000099;//user.Player:99
          _this.powc++;
          //$LASTPOS=15000115;//user.Player:115
          if (_this.powc>20&&Tonyu.globals.$ep.count()>0) {
            //$LASTPOS=15000159;//user.Player:159
            _this.attack(Tonyu.globals.$ep.random());
            
          }
          
        }
        //$LASTPOS=15000201;//user.Player:201
        _this.checkLife();
        //$LASTPOS=15000223;//user.Player:223
        _this.update();
        
      }
    },
    fiber$main :function _trc_Player_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=15000016;//user.Player:16
      _this.pow = 0;
      _this.powc = 0;
      
      
      _thread.enter(function _trc_Player_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=15000060;//user.Player:60
          case 1:
            //$LASTPOS=15000078;//user.Player:78
            if (!(_this.pow>0)) { __pc=4     ; break; }
            //$LASTPOS=15000099;//user.Player:99
            _this.powc++;
            //$LASTPOS=15000115;//user.Player:115
            if (!(_this.powc>20&&Tonyu.globals.$ep.count()>0)) { __pc=3     ; break; }
            //$LASTPOS=15000159;//user.Player:159
            _this.fiber$attack(_thread, Tonyu.globals.$ep.random());
            __pc=2;return;
          case 2:
            
          case 3     :
            
          case 4     :
            
            //$LASTPOS=15000201;//user.Player:201
            _this.fiber$checkLife(_thread);
            __pc=5;return;
          case 5:
            
            //$LASTPOS=15000223;//user.Player:223
            _this.fiber$update(_thread);
            __pc=6;return;
          case 6:
            
            __pc=1;break;
          case 7     :
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    incPow :function _trc_Player_incPow(p) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=15000253;//user.Player:253
      _this.pow+=p;
      //$LASTPOS=15000265;//user.Player:265
      _this.powc=0;
    },
    fiber$incPow :function _trc_Player_f_incPow(_thread,p) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=15000253;//user.Player:253
      _this.pow+=p;
      //$LASTPOS=15000265;//user.Player:265
      _this.powc=0;
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"incPow":{"nowait":false}},"fields":{"pow":{},"powc":{}}}
});
Tonyu.klass.define({
  fullName: 'user.PParty',
  shortName: 'PParty',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_PParty_main() {
      "use strict";
      var _this=this;
      
      
      //$LASTPOS=16000015;//user.PParty:15
      _this.p=1;
      //$LASTPOS=16000033;//user.PParty:33
      _this.pitch=_this.scr.width/Tonyu.globals.$colorc;
      //$LASTPOS=16000058;//user.PParty:58
      //$LASTPOS=16000063;//user.PParty:63
      _this.i = 0;
      for (; _this.i<Tonyu.globals.$colorc ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=16000092;//user.PParty:92
          _this.add(_this.i);
        }
      }
      //$LASTPOS=16000102;//user.PParty:102
      while (_this.all(Tonyu.classes.user.Player).length>=0) {
        Tonyu.checkLoop();
        //$LASTPOS=16000137;//user.PParty:137
        _this.update();
        
      }
      //$LASTPOS=16000149;//user.PParty:149
      Tonyu.globals.$console.locate(1,3);
      //$LASTPOS=16000171;//user.PParty:171
      Tonyu.globals.$console.print("Game Over");
      //$LASTPOS=16000200;//user.PParty:200
      new Tonyu.classes.kernel.Button({text: "Title",onClick: (function anonymous_232() {
        
        //$LASTPOS=16000243;//user.PParty:243
        new Tonyu.classes.kernel.FadeEffect({type: "out",page: Tonyu.classes.user.Menu});
      })});
    },
    fiber$main :function _trc_PParty_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      //$LASTPOS=16000015;//user.PParty:15
      _this.p=1;
      //$LASTPOS=16000033;//user.PParty:33
      _this.pitch=_this.scr.width/Tonyu.globals.$colorc;
      
      _thread.enter(function _trc_PParty_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=16000058;//user.PParty:58
            //$LASTPOS=16000063;//user.PParty:63
            _this.i = 0;
            
          case 1:
            if (!(_this.i<Tonyu.globals.$colorc)) { __pc=4     ; break; }
            //$LASTPOS=16000092;//user.PParty:92
            _this.fiber$add(_thread, _this.i);
            __pc=2;return;
          case 2:
            
          case 3     :
            _this.i++;
            __pc=1;break;
          case 4     :
            
            //$LASTPOS=16000102;//user.PParty:102
          case 5:
            if (!(_this.all(Tonyu.classes.user.Player).length>=0)) { __pc=7     ; break; }
            //$LASTPOS=16000137;//user.PParty:137
            _this.fiber$update(_thread);
            __pc=6;return;
          case 6:
            
            __pc=5;break;
          case 7     :
            
            //$LASTPOS=16000149;//user.PParty:149
            Tonyu.globals.$console.locate(1,3);
            //$LASTPOS=16000171;//user.PParty:171
            Tonyu.globals.$console.print("Game Over");
            //$LASTPOS=16000200;//user.PParty:200
            new Tonyu.classes.kernel.Button({text: "Title",onClick: (function anonymous_232() {
              
              //$LASTPOS=16000243;//user.PParty:243
              new Tonyu.classes.kernel.FadeEffect({type: "out",page: Tonyu.classes.user.Menu});
            })});
            _thread.exit(_this);return;
          }
        }
      });
    },
    add :function _trc_PParty_add(c) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=16000300;//user.PParty:300
      new Tonyu.classes.user.Player({x: (c+0.5)*_this.pitch,y: _this.scr.height-8,p: Tonyu.globals.$pat_player+c,col: c,fillStyle: Tonyu.globals.$colors[c],layer: _this.layer});
    },
    fiber$add :function _trc_PParty_f_add(_thread,c) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=16000300;//user.PParty:300
      new Tonyu.classes.user.Player({x: (c+0.5)*_this.pitch,y: _this.scr.height-8,p: Tonyu.globals.$pat_player+c,col: c,fillStyle: Tonyu.globals.$colors[c],layer: _this.layer});
      
      _thread.retVal=_this;return;
    },
    find :function _trc_PParty_find(c) {
      "use strict";
      var _this=this;
      
      return _this.all(Tonyu.classes.user.Player).find1({col: c});
    },
    fiber$find :function _trc_PParty_f_find(_thread,c) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      _thread.retVal=_this.all(Tonyu.classes.user.Player).find1({col: c});return;
      
      
      _thread.retVal=_this;return;
    },
    random :function _trc_PParty_random() {
      "use strict";
      var _this=this;
      
      return _this.all(Tonyu.classes.user.Player).random();
    },
    fiber$random :function _trc_PParty_f_random(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      _thread.retVal=_this.all(Tonyu.classes.user.Player).random();return;
      
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"add":{"nowait":false},"find":{"nowait":false},"random":{"nowait":false}},"fields":{"pitch":{},"scr":{},"i":{}}}
});
Tonyu.klass.define({
  fullName: 'user.PzScreen',
  shortName: 'PzScreen',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Screen,
  includes: [],
  methods: {
    main :function _trc_PzScreen_main() {
      "use strict";
      var _this=this;
      
      
    },
    fiber$main :function _trc_PzScreen_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      
      _thread.retVal=_this;return;
    },
    onAppear :function _trc_PzScreen_onAppear() {
      "use strict";
      var _this=this;
      var c;
      
      //$LASTPOS=17000053;//user.PzScreen:53
      _this.ballLayer=_this.addLayer();
      //$LASTPOS=17000079;//user.PzScreen:79
      _this.mat=new Tonyu.classes.kernel.Matrix;
      //$LASTPOS=17000099;//user.PzScreen:99
      Tonyu.globals.$zoomScreen=new Tonyu.classes.kernel.Screen({x: Tonyu.globals.$screenWidth/2,y: 100,width: 96,height: 96});
      //$LASTPOS=17000184;//user.PzScreen:184
      Tonyu.globals.$zoomScreen.addLayer(_this.ballLayer.group);
      //$LASTPOS=17000227;//user.PzScreen:227
      Tonyu.globals.$zoomScreen.selectLayer(_this.ballLayer.group);
      //$LASTPOS=17000273;//user.PzScreen:273
      Tonyu.globals.$zoomScreen.setPivot(48,48);
      //$LASTPOS=17000306;//user.PzScreen:306
      Tonyu.globals.$zoomScreen.alpha=0;
      //$LASTPOS=17000331;//user.PzScreen:331
      c = Tonyu.globals.$zoomScreen.context;
      
      //$LASTPOS=17000362;//user.PzScreen:362
      c.arc(48,48,48,0,Tonyu.globals.$Math.PI*2);
      //$LASTPOS=17000396;//user.PzScreen:396
      c.clip();
    },
    fiber$onAppear :function _trc_PzScreen_f_onAppear(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var c;
      
      
      _thread.enter(function _trc_PzScreen_ent_onAppear(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=17000053;//user.PzScreen:53
            _this.fiber$addLayer(_thread);
            __pc=1;return;
          case 1:
            _this.ballLayer=_thread.retVal;
            
            //$LASTPOS=17000079;//user.PzScreen:79
            _this.mat=new Tonyu.classes.kernel.Matrix;
            //$LASTPOS=17000099;//user.PzScreen:99
            Tonyu.globals.$zoomScreen=new Tonyu.classes.kernel.Screen({x: Tonyu.globals.$screenWidth/2,y: 100,width: 96,height: 96});
            //$LASTPOS=17000184;//user.PzScreen:184
            Tonyu.globals.$zoomScreen.addLayer(_this.ballLayer.group);
            //$LASTPOS=17000227;//user.PzScreen:227
            Tonyu.globals.$zoomScreen.selectLayer(_this.ballLayer.group);
            //$LASTPOS=17000273;//user.PzScreen:273
            Tonyu.globals.$zoomScreen.setPivot(48,48);
            //$LASTPOS=17000306;//user.PzScreen:306
            Tonyu.globals.$zoomScreen.alpha=0;
            //$LASTPOS=17000331;//user.PzScreen:331
            c = Tonyu.globals.$zoomScreen.context;
            
            //$LASTPOS=17000362;//user.PzScreen:362
            c.arc(48,48,48,0,Tonyu.globals.$Math.PI*2);
            //$LASTPOS=17000396;//user.PzScreen:396
            c.clip();
            _thread.exit(_this);return;
          }
        }
      });
    },
    zoom :function _trc_PzScreen_zoom(p) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=17000423;//user.PzScreen:423
      if (p) {
        //$LASTPOS=17000440;//user.PzScreen:440
        Tonyu.globals.$zoomScreen.alpha=255;
        //$LASTPOS=17000471;//user.PzScreen:471
        Tonyu.globals.$zoomScreen.scrollTo(p.x,p.y);
        
      } else {
        //$LASTPOS=17000523;//user.PzScreen:523
        Tonyu.globals.$zoomScreen.alpha=0;
        
      }
    },
    fiber$zoom :function _trc_PzScreen_f_zoom(_thread,p) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=17000423;//user.PzScreen:423
      if (p) {
        //$LASTPOS=17000440;//user.PzScreen:440
        Tonyu.globals.$zoomScreen.alpha=255;
        //$LASTPOS=17000471;//user.PzScreen:471
        Tonyu.globals.$zoomScreen.scrollTo(p.x,p.y);
        
      } else {
        //$LASTPOS=17000523;//user.PzScreen:523
        Tonyu.globals.$zoomScreen.alpha=0;
        
      }
      
      _thread.retVal=_this;return;
    },
    toLocal :function _trc_PzScreen_toLocal(touch) {
      "use strict";
      var _this=this;
      var pt;
      
      //$LASTPOS=17000574;//user.PzScreen:574
      touch.layer=_this.layer;
      //$LASTPOS=17000597;//user.PzScreen:597
      pt = _this.convert(touch);
      
      return pt;
    },
    fiber$toLocal :function _trc_PzScreen_f_toLocal(_thread,touch) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var pt;
      
      //$LASTPOS=17000574;//user.PzScreen:574
      touch.layer=_this.layer;
      
      _thread.enter(function _trc_PzScreen_ent_toLocal(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=17000597;//user.PzScreen:597
            _this.fiber$convert(_thread, touch);
            __pc=1;return;
          case 1:
            pt=_thread.retVal;
            
            _thread.exit(pt);return;
            _thread.exit(_this);return;
          }
        }
      });
    },
    grid :function _trc_PzScreen_grid(touch) {
      "use strict";
      var _this=this;
      var pt;
      var gx;
      var gy;
      
      //$LASTPOS=17000660;//user.PzScreen:660
      pt = _this.toLocal(touch);
      
      //$LASTPOS=17000687;//user.PzScreen:687
      gx = _this.floor(pt.x/32);
      gy = _this.floor(pt.y/32);
      
      return {gx: gx,gy: gy};
    },
    fiber$grid :function _trc_PzScreen_f_grid(_thread,touch) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var pt;
      var gx;
      var gy;
      
      
      _thread.enter(function _trc_PzScreen_ent_grid(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=17000660;//user.PzScreen:660
            _this.fiber$toLocal(_thread, touch);
            __pc=1;return;
          case 1:
            pt=_thread.retVal;
            
            //$LASTPOS=17000687;//user.PzScreen:687
            gx = _this.floor(pt.x/32);
            gy = _this.floor(pt.y/32);
            
            _thread.exit({gx: gx,gy: gy});return;
            _thread.exit(_this);return;
          }
        }
      });
    },
    ballOnTouch :function _trc_PzScreen_ballOnTouch(touch) {
      "use strict";
      var _this=this;
      var g;
      
      //$LASTPOS=17000776;//user.PzScreen:776
      g = _this.grid(touch);
      
      return _this.mat.get(g.gx,g.gy);
    },
    fiber$ballOnTouch :function _trc_PzScreen_f_ballOnTouch(_thread,touch) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var g;
      
      
      _thread.enter(function _trc_PzScreen_ent_ballOnTouch(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=17000776;//user.PzScreen:776
            _this.fiber$grid(_thread, touch);
            __pc=1;return;
          case 1:
            g=_thread.retVal;
            
            _thread.exit(_this.mat.get(g.gx,g.gy));return;
            _thread.exit(_this);return;
          }
        }
      });
    },
    getSBall :function _trc_PzScreen_getSBall(gx,gy) {
      "use strict";
      var _this=this;
      
      return _this.mat.get(gx,gy);
    },
    fiber$getSBall :function _trc_PzScreen_f_getSBall(_thread,gx,gy) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      _thread.retVal=_this.mat.get(gx,gy);return;
      
      
      _thread.retVal=_this;return;
    },
    rm :function _trc_PzScreen_rm(gx,gy) {
      "use strict";
      var _this=this;
      var b;
      
      //$LASTPOS=17000950;//user.PzScreen:950
      b = _this.mat.get(gx,gy);
      
      //$LASTPOS=17000976;//user.PzScreen:976
      if (b) {
        //$LASTPOS=17000993;//user.PzScreen:993
        b.die();
        //$LASTPOS=17001010;//user.PzScreen:1010
        _this.mat.set(gx,gy);
        return b;
        
      }
    },
    fiber$rm :function _trc_PzScreen_f_rm(_thread,gx,gy) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var b;
      
      //$LASTPOS=17000950;//user.PzScreen:950
      b = _this.mat.get(gx,gy);
      
      //$LASTPOS=17000976;//user.PzScreen:976
      if (b) {
        //$LASTPOS=17000993;//user.PzScreen:993
        b.die();
        //$LASTPOS=17001010;//user.PzScreen:1010
        _this.mat.set(gx,gy);
        _thread.retVal=b;return;
        
        
      }
      
      _thread.retVal=_this;return;
    },
    fill :function _trc_PzScreen_fill() {
      "use strict";
      var _this=this;
      var j;
      var i;
      var n;
      var b;
      
      
      //$LASTPOS=17001079;//user.PzScreen:1079
      //$LASTPOS=17001084;//user.PzScreen:1084
      j=0;for (; j<Tonyu.globals.$c ; j++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=17001108;//user.PzScreen:1108
          n = 0;
          
          //$LASTPOS=17001125;//user.PzScreen:1125
          //$LASTPOS=17001130;//user.PzScreen:1130
          i=Tonyu.globals.$r-1;for (; i>=0 ; i--) {
            Tonyu.checkLoop();
            {
              //$LASTPOS=17001162;//user.PzScreen:1162
              b = _this.getSBall(j,i);
              
              //$LASTPOS=17001195;//user.PzScreen:1195
              if (! b) {
                //$LASTPOS=17001221;//user.PzScreen:1221
                n++;
                
              } else {
                //$LASTPOS=17001263;//user.PzScreen:1263
                if (n) {
                  //$LASTPOS=17001292;//user.PzScreen:1292
                  _this.rm(j,i);
                  //$LASTPOS=17001321;//user.PzScreen:1321
                  _this.genDBall(j,i,b.p);
                  
                }
                
              }
            }
          }
          //$LASTPOS=17001390;//user.PzScreen:1390
          //$LASTPOS=17001395;//user.PzScreen:1395
          i=- 1;for (; i>=- n ; i--) {
            Tonyu.checkLoop();
            {
              //$LASTPOS=17001425;//user.PzScreen:1425
              _this.genDBall(j,i,Tonyu.globals.$pat_iroball+_this.rnd(25));
            }
          }
        }
      }
    },
    fiber$fill :function _trc_PzScreen_f_fill(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var j;
      var i;
      var n;
      var b;
      
      
      
      _thread.enter(function _trc_PzScreen_ent_fill(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=17001079;//user.PzScreen:1079
            //$LASTPOS=17001084;//user.PzScreen:1084
            j=0;
          case 1:
            if (!(j<Tonyu.globals.$c)) { __pc=16    ; break; }
            //$LASTPOS=17001108;//user.PzScreen:1108
            n = 0;
            
            //$LASTPOS=17001125;//user.PzScreen:1125
            //$LASTPOS=17001130;//user.PzScreen:1130
            i=Tonyu.globals.$r-1;
          case 2:
            if (!(i>=0)) { __pc=10    ; break; }
            //$LASTPOS=17001162;//user.PzScreen:1162
            _this.fiber$getSBall(_thread, j, i);
            __pc=3;return;
          case 3:
            b=_thread.retVal;
            
            //$LASTPOS=17001195;//user.PzScreen:1195
            if (!(! b)) { __pc=4     ; break; }
            {
              //$LASTPOS=17001221;//user.PzScreen:1221
              n++;
            }
            __pc=8     ;break;
          case 4     :
            //$LASTPOS=17001263;//user.PzScreen:1263
            if (!(n)) { __pc=7     ; break; }
            //$LASTPOS=17001292;//user.PzScreen:1292
            _this.fiber$rm(_thread, j, i);
            __pc=5;return;
          case 5:
            
            //$LASTPOS=17001321;//user.PzScreen:1321
            _this.fiber$genDBall(_thread, j, i, b.p);
            __pc=6;return;
          case 6:
            
          case 7     :
            
          case 8     :
            
          case 9     :
            i--;
            __pc=2;break;
          case 10    :
            
            //$LASTPOS=17001390;//user.PzScreen:1390
            //$LASTPOS=17001395;//user.PzScreen:1395
            i=- 1;
          case 11:
            if (!(i>=- n)) { __pc=14    ; break; }
            //$LASTPOS=17001425;//user.PzScreen:1425
            _this.fiber$genDBall(_thread, j, i, Tonyu.globals.$pat_iroball+_this.rnd(25));
            __pc=12;return;
          case 12:
            
          case 13    :
            i--;
            __pc=11;break;
          case 14    :
            
          case 15    :
            j++;
            __pc=1;break;
          case 16    :
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    genSBall :function _trc_PzScreen_genSBall(gx,gy,p) {
      "use strict";
      var _this=this;
      var sb;
      
      //$LASTPOS=17001505;//user.PzScreen:1505
      sb = new Tonyu.classes.user.Ball({x: gx*32+16,y: gy*32+16,p: p,layer: _this.ballLayer,scr: _this});
      
      //$LASTPOS=17001628;//user.PzScreen:1628
      _this.mat.set(gx,gy,sb);
      return sb;
    },
    fiber$genSBall :function _trc_PzScreen_f_genSBall(_thread,gx,gy,p) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var sb;
      
      //$LASTPOS=17001505;//user.PzScreen:1505
      sb = new Tonyu.classes.user.Ball({x: gx*32+16,y: gy*32+16,p: p,layer: _this.ballLayer,scr: _this});
      
      //$LASTPOS=17001628;//user.PzScreen:1628
      _this.mat.set(gx,gy,sb);
      _thread.retVal=sb;return;
      
      
      _thread.retVal=_this;return;
    },
    genDBall :function _trc_PzScreen_genDBall(gx,gy,p) {
      "use strict";
      var _this=this;
      
      return new Tonyu.classes.user.DBall({x: gx*32+16,y: gy*32+16,p: p,layer: _this.ballLayer,scr: _this});
    },
    fiber$genDBall :function _trc_PzScreen_f_genDBall(_thread,gx,gy,p) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      _thread.retVal=new Tonyu.classes.user.DBall({x: gx*32+16,y: gy*32+16,p: p,layer: _this.ballLayer,scr: _this});return;
      
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"onAppear":{"nowait":false},"zoom":{"nowait":false},"toLocal":{"nowait":false},"grid":{"nowait":false},"ballOnTouch":{"nowait":false},"getSBall":{"nowait":false},"rm":{"nowait":false},"fill":{"nowait":false},"genSBall":{"nowait":false},"genDBall":{"nowait":false}},"fields":{"ballLayer":{},"mat":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Turtle',
  shortName: 'Turtle',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_Turtle_main() {
      "use strict";
      var _this=this;
      
      
    },
    fiber$main :function _trc_Turtle_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      
      _thread.retVal=_this;return;
    },
    initialize :function _trc_Turtle_initialize(context,x,y) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=18000073;//user.Turtle:73
      _this.context=context;
      //$LASTPOS=18000099;//user.Turtle:99
      if (typeof  x==="number"&&typeof  y==="number") {
        //$LASTPOS=18000157;//user.Turtle:157
        _this.x=x;
        //$LASTPOS=18000175;//user.Turtle:175
        _this.y=y;
        //$LASTPOS=18000193;//user.Turtle:193
        _this.px=x;
        //$LASTPOS=18000207;//user.Turtle:207
        _this.py=y;
        
      } else {
        //$LASTPOS=18000234;//user.Turtle:234
        x=0;
        //$LASTPOS=18000238;//user.Turtle:238
        y=0;
        
      }
      //$LASTPOS=18000253;//user.Turtle:253
      _this.dir=0;
      //$LASTPOS=18000264;//user.Turtle:264
      _this.autoDraw=true;
      //$LASTPOS=18000283;//user.Turtle:283
      _this.doFill=true;
    },
    __setter__lineWidth :function _trc_Turtle___setter__lineWidth(x) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=18000317;//user.Turtle:317
      _this.context.lineWidth=x;
    },
    __setter__fillStyle :function _trc_Turtle___setter__fillStyle(f) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=18000359;//user.Turtle:359
      _this.context.fillStyle=f;
      //$LASTPOS=18000384;//user.Turtle:384
      _this.doFill=! ! f;
    },
    __setter__strokeStyle :function _trc_Turtle___setter__strokeStyle(f) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=18000419;//user.Turtle:419
      _this.doStroke=! ! f;
      //$LASTPOS=18000437;//user.Turtle:437
      _this.context.strokeStyle=f;
    },
    beginPath :function _trc_Turtle_beginPath() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=18000481;//user.Turtle:481
      _this.context.beginPath();
      //$LASTPOS=18000506;//user.Turtle:506
      _this.autoDraw=false;
      //$LASTPOS=18000526;//user.Turtle:526
      _this.px=null;
    },
    fiber$beginPath :function _trc_Turtle_f_beginPath(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=18000481;//user.Turtle:481
      _this.context.beginPath();
      //$LASTPOS=18000506;//user.Turtle:506
      _this.autoDraw=false;
      //$LASTPOS=18000526;//user.Turtle:526
      _this.px=null;
      
      _thread.retVal=_this;return;
    },
    closePath :function _trc_Turtle_closePath() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=18000556;//user.Turtle:556
      _this.context.closePath();
      //$LASTPOS=18000581;//user.Turtle:581
      _this.autoDraw=true;
    },
    fiber$closePath :function _trc_Turtle_f_closePath(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=18000556;//user.Turtle:556
      _this.context.closePath();
      //$LASTPOS=18000581;//user.Turtle:581
      _this.autoDraw=true;
      
      _thread.retVal=_this;return;
    },
    rotate :function _trc_Turtle_rotate(r) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=18000615;//user.Turtle:615
      _this.dir+=r;
    },
    fiber$rotate :function _trc_Turtle_f_rotate(_thread,r) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=18000615;//user.Turtle:615
      _this.dir+=r;
      
      _thread.retVal=_this;return;
    },
    forward :function _trc_Turtle_forward(s) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=18000643;//user.Turtle:643
      _this.x+=_this.cos(_this.dir)*s;
      //$LASTPOS=18000662;//user.Turtle:662
      _this.y+=_this.sin(_this.dir)*s;
      //$LASTPOS=18000681;//user.Turtle:681
      _this.lineTo(_this.x,_this.y);
    },
    fiber$forward :function _trc_Turtle_f_forward(_thread,s) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=18000643;//user.Turtle:643
      _this.x+=_this.cos(_this.dir)*s;
      //$LASTPOS=18000662;//user.Turtle:662
      _this.y+=_this.sin(_this.dir)*s;
      
      _thread.enter(function _trc_Turtle_ent_forward(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=18000681;//user.Turtle:681
            _this.fiber$lineTo(_thread, _this.x, _this.y);
            __pc=1;return;
          case 1:
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    moveTo :function _trc_Turtle_moveTo(x,y) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=18000715;//user.Turtle:715
      _this.x=x;
      //$LASTPOS=18000729;//user.Turtle:729
      _this.y=y;
      //$LASTPOS=18000743;//user.Turtle:743
      _this.px=x;
      //$LASTPOS=18000753;//user.Turtle:753
      _this.py=y;
      //$LASTPOS=18000763;//user.Turtle:763
      _this.context.moveTo(x,y);
    },
    fiber$moveTo :function _trc_Turtle_f_moveTo(_thread,x,y) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=18000715;//user.Turtle:715
      _this.x=x;
      //$LASTPOS=18000729;//user.Turtle:729
      _this.y=y;
      //$LASTPOS=18000743;//user.Turtle:743
      _this.px=x;
      //$LASTPOS=18000753;//user.Turtle:753
      _this.py=y;
      //$LASTPOS=18000763;//user.Turtle:763
      _this.context.moveTo(x,y);
      
      _thread.retVal=_this;return;
    },
    moveBy :function _trc_Turtle_moveBy(bx,by) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=18000807;//user.Turtle:807
      _this.moveTo(_this.x+bx,_this.y+by);
    },
    fiber$moveBy :function _trc_Turtle_f_moveBy(_thread,bx,by) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      _thread.enter(function _trc_Turtle_ent_moveBy(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=18000807;//user.Turtle:807
            _this.fiber$moveTo(_thread, _this.x+bx, _this.y+by);
            __pc=1;return;
          case 1:
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    lineBy :function _trc_Turtle_lineBy(bx,by) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=18000849;//user.Turtle:849
      _this.lineTo(_this.x+bx,_this.y+by);
    },
    fiber$lineBy :function _trc_Turtle_f_lineBy(_thread,bx,by) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      _thread.enter(function _trc_Turtle_ent_lineBy(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=18000849;//user.Turtle:849
            _this.fiber$lineTo(_thread, _this.x+bx, _this.y+by);
            __pc=1;return;
          case 1:
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    lineTo :function _trc_Turtle_lineTo(x,y) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=18000889;//user.Turtle:889
      _this.x=x;
      //$LASTPOS=18000903;//user.Turtle:903
      _this.y=y;
      //$LASTPOS=18000917;//user.Turtle:917
      if (_this.px==null) {
        //$LASTPOS=18000941;//user.Turtle:941
        _this.px=x;
        //$LASTPOS=18000946;//user.Turtle:946
        _this.py=y;
        return _this;
        
      }
      //$LASTPOS=18000969;//user.Turtle:969
      if (_this.autoDraw) {
        //$LASTPOS=18000993;//user.Turtle:993
        _this.enter((function anonymous_998() {
          
          //$LASTPOS=18001013;//user.Turtle:1013
          _this.context.beginPath();
          //$LASTPOS=18001046;//user.Turtle:1046
          _this.context.moveTo(_this.px,_this.py);
          //$LASTPOS=18001081;//user.Turtle:1081
          _this.context.lineTo(x,y);
          //$LASTPOS=18001114;//user.Turtle:1114
          _this.context.closePath();
          //$LASTPOS=18001147;//user.Turtle:1147
          _this.fillAndStroke();
        }));
        
      } else {
        //$LASTPOS=18001196;//user.Turtle:1196
        _this.context.lineTo(x,y);
        
      }
      //$LASTPOS=18001227;//user.Turtle:1227
      _this.px=x;
      //$LASTPOS=18001232;//user.Turtle:1232
      _this.py=y;
    },
    fiber$lineTo :function _trc_Turtle_f_lineTo(_thread,x,y) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=18000889;//user.Turtle:889
      _this.x=x;
      //$LASTPOS=18000903;//user.Turtle:903
      _this.y=y;
      //$LASTPOS=18000917;//user.Turtle:917
      if (_this.px==null) {
        //$LASTPOS=18000941;//user.Turtle:941
        _this.px=x;
        //$LASTPOS=18000946;//user.Turtle:946
        _this.py=y;
        _thread.retVal=_this;return;
        
        
      }
      
      _thread.enter(function _trc_Turtle_ent_lineTo(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=18000969;//user.Turtle:969
            if (!(_this.autoDraw)) { __pc=2     ; break; }
            //$LASTPOS=18000993;//user.Turtle:993
            _this.fiber$enter(_thread, (function anonymous_998() {
              
              //$LASTPOS=18001013;//user.Turtle:1013
              _this.context.beginPath();
              //$LASTPOS=18001046;//user.Turtle:1046
              _this.context.moveTo(_this.px,_this.py);
              //$LASTPOS=18001081;//user.Turtle:1081
              _this.context.lineTo(x,y);
              //$LASTPOS=18001114;//user.Turtle:1114
              _this.context.closePath();
              //$LASTPOS=18001147;//user.Turtle:1147
              _this.fillAndStroke();
            }));
            __pc=1;return;
          case 1:
            
            __pc=3     ;break;
          case 2     :
            {
              //$LASTPOS=18001196;//user.Turtle:1196
              _this.context.lineTo(x,y);
            }
          case 3     :
            
            //$LASTPOS=18001227;//user.Turtle:1227
            _this.px=x;
            //$LASTPOS=18001232;//user.Turtle:1232
            _this.py=y;
            _thread.exit(_this);return;
          }
        }
      });
    },
    circle :function _trc_Turtle_circle(r) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=18001257;//user.Turtle:1257
      _this.enter((function anonymous_1262() {
        
        //$LASTPOS=18001273;//user.Turtle:1273
        _this.context.beginPath();
        //$LASTPOS=18001302;//user.Turtle:1302
        _this.context.arc(_this.x,_this.y,r,0,Tonyu.globals.$Math.PI*2);
        //$LASTPOS=18001343;//user.Turtle:1343
        _this.context.closePath();
        //$LASTPOS=18001372;//user.Turtle:1372
        _this.fillAndStroke();
      }));
    },
    fiber$circle :function _trc_Turtle_f_circle(_thread,r) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      _thread.enter(function _trc_Turtle_ent_circle(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=18001257;//user.Turtle:1257
            _this.fiber$enter(_thread, (function anonymous_1262() {
              
              //$LASTPOS=18001273;//user.Turtle:1273
              _this.context.beginPath();
              //$LASTPOS=18001302;//user.Turtle:1302
              _this.context.arc(_this.x,_this.y,r,0,Tonyu.globals.$Math.PI*2);
              //$LASTPOS=18001343;//user.Turtle:1343
              _this.context.closePath();
              //$LASTPOS=18001372;//user.Turtle:1372
              _this.fillAndStroke();
            }));
            __pc=1;return;
          case 1:
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    fillAndStroke :function _trc_Turtle_fillAndStroke() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=18001421;//user.Turtle:1421
      if (_this.doFill) {
        //$LASTPOS=18001433;//user.Turtle:1433
        _this.context.fill();
      }
      //$LASTPOS=18001453;//user.Turtle:1453
      if (_this.doStroke) {
        //$LASTPOS=18001467;//user.Turtle:1467
        _this.context.stroke();
      }
    },
    fiber$fillAndStroke :function _trc_Turtle_f_fillAndStroke(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=18001421;//user.Turtle:1421
      if (_this.doFill) {
        //$LASTPOS=18001433;//user.Turtle:1433
        _this.context.fill();
      }
      //$LASTPOS=18001453;//user.Turtle:1453
      if (_this.doStroke) {
        //$LASTPOS=18001467;//user.Turtle:1467
        _this.context.stroke();
      }
      
      _thread.retVal=_this;return;
    },
    enter :function _trc_Turtle_enter(f) {
      "use strict";
      var _this=this;
      var ee;
      var e;
      
      //$LASTPOS=18001503;//user.Turtle:1503
      _this.context.save();
      
      try {
        //$LASTPOS=18001549;//user.Turtle:1549
        f();
        
      } catch (e) {
        //$LASTPOS=18001579;//user.Turtle:1579
        ee=e;
        
      }
      //$LASTPOS=18001595;//user.Turtle:1595
      _this.context.restore();
      //$LASTPOS=18001618;//user.Turtle:1618
      if (ee) {
        throw ee;
        
      }
    },
    fiber$enter :function _trc_Turtle_f_enter(_thread,f) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var ee;
      var e;
      
      //$LASTPOS=18001503;//user.Turtle:1503
      _this.context.save();
      
      try {
        //$LASTPOS=18001549;//user.Turtle:1549
        f();
        
      } catch (e) {
        //$LASTPOS=18001579;//user.Turtle:1579
        ee=e;
        
      }
      //$LASTPOS=18001595;//user.Turtle:1595
      _this.context.restore();
      //$LASTPOS=18001618;//user.Turtle:1618
      if (ee) {
        throw ee;
        
      }
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"__setter__lineWidth":{"nowait":true},"__setter__fillStyle":{"nowait":true},"__setter__strokeStyle":{"nowait":true},"beginPath":{"nowait":false},"closePath":{"nowait":false},"rotate":{"nowait":false},"forward":{"nowait":false},"moveTo":{"nowait":false},"moveBy":{"nowait":false},"lineBy":{"nowait":false},"lineTo":{"nowait":false},"circle":{"nowait":false},"fillAndStroke":{"nowait":false},"enter":{"nowait":false}},"fields":{"context":{},"px":{},"py":{},"dir":{},"autoDraw":{},"doFill":{},"doStroke":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Enemy',
  shortName: 'Enemy',
  namespace: 'user',
  superclass: Tonyu.classes.user.Member,
  includes: [],
  methods: {
    main :function _trc_Enemy_main() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=19000048;//user.Enemy:48
      while (true) {
        Tonyu.checkLoop();
        //$LASTPOS=19000067;//user.Enemy:67
        if (_this.rnd(50)==0) {
          //$LASTPOS=19000083;//user.Enemy:83
          _this.skill+=1;
        }
        //$LASTPOS=19000097;//user.Enemy:97
        if (_this.skill>=_this.skillMax) {
          //$LASTPOS=19000128;//user.Enemy:128
          _this.pow=5;
          //$LASTPOS=19000143;//user.Enemy:143
          _this.attack(Tonyu.globals.$pp.random());
          //$LASTPOS=19000173;//user.Enemy:173
          _this.skill=0;
          
        }
        //$LASTPOS=19000192;//user.Enemy:192
        _this.quake=_this.skill/_this.skillMax;
        //$LASTPOS=19000218;//user.Enemy:218
        _this.checkLife();
        //$LASTPOS=19000235;//user.Enemy:235
        _this.update();
        
      }
    },
    fiber$main :function _trc_Enemy_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      _thread.enter(function _trc_Enemy_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=19000048;//user.Enemy:48
          case 1:
            //$LASTPOS=19000067;//user.Enemy:67
            if (_this.rnd(50)==0) {
              //$LASTPOS=19000083;//user.Enemy:83
              _this.skill+=1;
            }
            //$LASTPOS=19000097;//user.Enemy:97
            if (!(_this.skill>=_this.skillMax)) { __pc=3     ; break; }
            //$LASTPOS=19000128;//user.Enemy:128
            _this.pow=5;
            //$LASTPOS=19000143;//user.Enemy:143
            _this.fiber$attack(_thread, Tonyu.globals.$pp.random());
            __pc=2;return;
          case 2:
            
            //$LASTPOS=19000173;//user.Enemy:173
            _this.skill=0;
          case 3     :
            
            //$LASTPOS=19000192;//user.Enemy:192
            _this.quake=_this.skill/_this.skillMax;
            //$LASTPOS=19000218;//user.Enemy:218
            _this.fiber$checkLife(_thread);
            __pc=4;return;
          case 4:
            
            //$LASTPOS=19000235;//user.Enemy:235
            _this.fiber$update(_thread);
            __pc=5;return;
          case 5:
            
            __pc=1;break;
          case 6     :
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    incPow :function _trc_Enemy_incPow(p) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=19000035;//user.Enemy:35
      _this.skill+=p;
    },
    fiber$incPow :function _trc_Enemy_f_incPow(_thread,p) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=19000035;//user.Enemy:35
      _this.skill+=p;
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"incPow":{"nowait":false}},"fields":{}}
});

//# sourceMappingURL=concat.js.map